
#include 'Include/Include.au3'
#include <Array.au3>

HotKeySet('{F5}', _F5)

#cs

Sonstiges:
drawcallstack = 128 Calls. Danach ist ein drawflush nötig.
der Stack ist pro Prozessor und nicht pro Leinwand.

Originaler Sprachumfang:

Known Bugs (in Mindustry)
- LineCaps zu groß, wenn man stroke(2) nutzt ist Start und Ende ein paar Px zu lang bei draw line. (TODO: Nachprüfen ob das immernoch so ist, die info ist 2 Jahre alt)

Makros:
@links = Anzahl der verlinkten Sachen die man mit getLink(123) bekommen kann.
@time  = unix time = millisekunden seit 01.01.1970
@tick  = tick (60/sek) seit mapstart
@counter = Hier steht der Pointer auf die nächste Instruktion.
@unit  = ??? vermutlich eine Einheit?
@ipt   = instructions per tick (was bringt das? -> herausfinden wie schnell der Prozessor ist.)
@this  = selbstreferenz, kann man wie "container1" nutzen
@thisx = X-Position des Prozessors
@thisY = Y-Position des Prozessors

; Ein Counter der alle 60 Ticks um 1 hochzählt

set tick @tick
op sub newTick @tick 60
jump 11 lessThanEq newTick tick
op add tick tick 60
read frame cell1 0
read resetFlag cell1 1
jump 9 equal resetFlag 0
write 0 cell1 1
set frame 0
op add frame frame 1
write frame cell1 0
jump 1 always 0 0


TODO:

If (Chance(0.5)) ...
If (Random(a, b) logic c) ...

; Rechnungen mit 3 variablen
array[varornumber(*)varornumber(+)varornumber]
array[varornumber(*)varornumber]

#ce

Global Const $sVersion = '0.1'
Global Const $GUI_Width = 900, $GUI_Height = Round($GUI_Width / 16 * 10)

Global $bCompile = False

Global $hGUI = GUICreate('Mindustry Logic Compiler ' & $sVersion, $GUI_Width + 100, $GUI_Height)

Global $hEdit_In = GUICtrlCreateEdit($sExample_Ball, 0, 5, Int($GUI_Width/2), $GUI_Height - $GUI_Height / 4  - 40)
Global $hEdit_Out =     GUICtrlCreateEdit('', Int($GUI_Width/2), 35, Int($GUI_Width/2), $GUI_Height - $GUI_Height / 4 - 70)
Global $hEdit_Console = GUICtrlCreateEdit('', 0, $GUI_Height - $GUI_Height / 4 - 40 + 5, $GUI_Width, $GUI_Height / 4)
Global $hBtn_Compile = GUICtrlCreateButton('Compile', $GUI_Width/2 - 100/2, $GUI_Height - 40 + 10, 100, 25)

Global $hBtn_LoadTest = GUICtrlCreateButton('Load Test', $GUI_Width + 5, 5, 90, 25)
Global $hBtn_PrimeNumbers = GUICtrlCreateButton('Ex1: Primes', $GUI_Width + 5, 35, 90, 25)
Global $hBtn_Balls = GUICtrlCreateButton('Ex2: Ball', $GUI_Width + 5, 35 + 30, 90, 25)
Global $hBtn_Array = GUICtrlCreateButton('Ex3: Bricks', $GUI_Width + 5, 35 + 30 + 30, 90, 25)
Global $hBtn_DCell = GUICtrlCreateButton('Ex4: Dump Cell', $GUI_Width + 5, 35 + 30 + 30 + 30, 90, 25)


Global $aCompileStageOutput[6]
Global $aCompileStageButtons = ButtonsCreate()

Func ButtonsCreate()
	Local $aButtons[UBound($aCompileStageOutput)], $border = 30, $_ = Int($GUI_Width/2 - $border*2) / UBound($aCompileStageOutput)
	Local $aName = ['Cleanup', 'Asm', 'Labels', 'Flow', 'Multiline', 'Prepare']
	For $i = 0 To UBound($aButtons) - 1 Step 1
		$aButtons[$i] = GUICtrlCreateButton($i & ': ' & $aName[$i], Int($GUI_Width/2) + $i * $_ + $border, 5, $_, 25)
	Next
	Return $aButtons
EndFunc

GUICtrlSetFont($hEdit_In, 9, 400, 0, 'Consolas')
GUICtrlSetFont($hEdit_Out, 9, 400, 0, 'Consolas')
GUICtrlSetFont($hEdit_Console, 9, 400, 0, 'Consolas')

GUISetState()

While True
	$iMsg = GUIGetMsg()
	Switch $iMsg
		Case -3
			Exit
		Case $hBtn_Compile
			$bCompile = True
		Case $hBtn_LoadTest
			GUICtrlSetData($hEdit_In, $sTest)
		Case $hBtn_PrimeNumbers
			GUICtrlSetData($hEdit_In, $sExample_PrimeNumbers)
		Case $hBtn_Balls
			GUICtrlSetData($hEdit_In, $sExample_Ball)
		Case $hBtn_Array
			GUICtrlSetData($hEdit_In, $sExample_Array)
		Case $hBtn_DCell
			GUICtrlSetData($hEdit_In, $sExample_DumpCell)
		Case $aCompileStageButtons[0] To $aCompileStageButtons[UBound($aCompileStageButtons)-1]
			GUICtrlSetData($hEdit_Out, $aCompileStageOutput[$iMsg - $aCompileStageButtons[0]])

	EndSwitch
	If $bCompile Then
		$bCompile = False
		GUICtrlSetData($hEdit_Out, Compile(GUICtrlRead($hEdit_In)))
	EndIf
WEnd

Func Compile($sString)
	Local $t = TimerInit()
	; Die verschiedenen Stages bauen aufeinander auf.
	; z.B. For-Schleifen können ohne Labels nicht funktionieren -> Stage2 vorraussetzung für Stage3
	ConsoleReset()
	_Compile_Stage_Z($sString)
	$aCompileStageOutput[5] = AddLineNumbers($sString)
	_Compile_Stage_4($sString)
	$aCompileStageOutput[4] = AddLineNumbers($sString)
	_Compile3($sString)
	$aCompileStageOutput[3] = AddLineNumbers($sString)
	_Compile_Stage_2($sString)
	$aCompileStageOutput[2] = AddLineNumbers($sString)
	_Compile1($sString)
	$aCompileStageOutput[1] = AddLineNumbers($sString)
	_Compile_Stage_0($sString)
	$aCompileStageOutput[0] = $sString
	ErrorShow(TimerDiff($t))
	Return $sString
EndFunc

Func AddLineNumbers(ByRef $s)
	Local $a = StringSplit($s, @CRLF, 3), $r = ''
	For $i = 0 To UBound($a) - 1 Step 1
		$r &= '[' & StringRight('   ' & $i, 3) & '] ' & $a[$i] & @CRLF
	Next
	Return $r
EndFunc

Func ErrorShow($nCompileTime)
	Local $a
	While UBound($aError)
		$a = ArrayPop($aError)
		Console($a[0], $a[1], $a[2], $a[3], $a[4], $a[5])
	WEnd
	GUICtrlSetData($hEdit_Console, 'Compiletime: ' & Round($nCompileTime) & ' ms' & @CRLF, 1)
EndFunc

Func Console($iStage, $iLine, $sLine, $iErrorCode, $sErrorString, $sFix = '')
	Local $c = (IsInt($iStage) ? Hex($iStage, 1) : $iStage) & Hex($iErrorCode, 1)
	GUICtrlSetData($hEdit_Console, '[Stage ' & StringRight('  ' & $iStage, 2) & '] ERROR' & $c & ': ' & $sErrorString & @CRLF, 1)
	GUICtrlSetData($hEdit_Console, '--[Line ' & StringRight('   ' & $iLine, 3) & '] > ' & $sLine & ' <' & @CRLF, 1)
	If $sFix <> '' Then GUICtrlSetData($hEdit_Console, '----[Fix     ] ' & $sFix & @CRLF, 1)
EndFunc

Func ConsoleReset()
	GUICtrlSetData($hEdit_Console, '')
EndFunc

Func _F5()
	If WinActive($hGUI) Then
		$bCompile = True
	EndIf
EndFunc
