#include-once
#include '../Util.au3'

; Nur inline replacements, also Sachen die 1:1 übersetzt wereden könneen und dabei eine Zeile auf eine Zeile abbilden.

Func _Compile_Stage_1(ByRef $sString)
	Local $aString = StringSplit($sString, @CRLF, 3), $sRet = '', $a
	Local Static $aReplacementFunctions = [ _
	__Compile_Stage_1_InlineReplacements_Flow, _
	__Compile_Stage_1_InlineReplacements_Print, _
	__Compile_Stage_1_InlineReplacements_Jump, _
	__Compile_Stage_1_InlineReplacements_Control, _
	__Compile_Stage_1_InlineReplacements_Op, _
	__Compile_Stage_1_InlineReplacements_Draw, _
	__Compile_Stage_1_InlineReplacements_Radar, _ ; TODO
	__Compile_Stage_1_InlineReplacements_Unit] ; TODO
	Local Const $EX_read        = $EX_VAR&'=read\('&$EX_VAR&','&$EX_VAR&'\)'
	Local Const $EX_write       = 'write\('&$EX_VAR&','&$EX_VAR&','&$EX_VAR&'\)'
	Local Const $EX_sensor      = $EX_VAR&'=read\('&$EX_VAR&',@'&$EX_VAR&'\)' ; sensor (heißt hier auch read, weil es ansich "lesen" ist)
	Local Const $EX_set         = $EX_VAR&'='&$EX_VAR&''
	Local Const $EX_getlink     = $EX_VAR&'=getlink\('&$EX_VAR&'\)'
	Local $n = 0
	For $i = 0 To UBound($aString) - 1 Step 1
		If Not $aString[$i] Then ContinueLoop
		$n = 0
		For $x In $aReplacementFunctions
			If $n = 0 Then $n += $x($aString, $i)
		Next
		If $n = 0 Then
			$n = 1
			Select
				Case StringRegExpMatchLine($aString[$i], $EX_read)
					$a = Split($aString[$i], '=', '', ',', 0, 1, 0, 0, 5)
					$aString[$i] = 'read ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
				Case StringRegExpMatchLine($aString[$i], $EX_write)
					$a = Split($aString[$i], ',', '', '', 6, 1)
					$aString[$i] = 'write' & ' ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
				Case StringRegExpMatchLine($aString[$i], $EX_sensor)
					$a = Split($aString[$i], '=', '', ',', 0, 1, 0, 0, 5, 0)
					$aString[$i] = 'sensor ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
				Case StringRegExpMatchLine($aString[$i], $EX_set)
					$a = Split($aString[$i], '=')
					$aString[$i] = 'set ' & $a[0] & ' ' & $a[1]
				Case StringRegExpMatchLine($aString[$i], $EX_getlink)
					$a = Split($aString[$i], '=')
					$aString[$i] = 'getlink ' & $a[0] & ' ' & StringTrimBoth($a[1], 8, 1)
				Case Else
					$n = 0
			EndSelect
		EndIf
		If $n = 0 Then ErrorPush(1, $i, $aString[$i], 1, 'could not translate this')
		$sRet &= $aString[$i] & @CRLF
	Next
	$sString = StringTrimRight($sRet, 2)
EndFunc

Func __Compile_Stage_1_InlineReplacements_Print(ByRef $aString, $i) ; Done
	Local $iRet = 1
	Local Const $w = StringReplace($REGEX_CHAR_VAR, ' ', '', 0, 1) ; wenn Spaces erlaubt sind (ausschließlich in Strings)
	Local Const $EX_print_str = 'print\("' & $w & '*"\)'
	Local Const $EX_print_var = 'print\(' & $EX_VAR & '\)'
	Local Const $EX_print_flush = 'printflush\(' & $EX_VAR & '\)'
	Select
		Case StringRegExpMatchLine($aString[$i], $EX_print_str)
			$aString[$i] = 'print ' & StringTrimBoth($aString[$i], 6, 1)
		Case StringRegExpMatchLine($aString[$i], $EX_print_var)
			$aString[$i] = 'print ' & StringTrimBoth($aString[$i], 6, 1)
		Case StringRegExpMatchLine($aString[$i], $EX_print_flush)
			$aString[$i] = 'printflush' & ' ' & StringTrimRight(StringSplit($aString[$i], '(', 2)[1], 1)
		Case Else
			$iRet = 0
	EndSelect
	Return $iRet
EndFunc   ;==>__Compile_Stage_1_InlineReplacements_Print

Func __Compile_Stage_1_InlineReplacements_Flow(ByRef $aString, $i) ; Done
	Local $iRet = 1, $a
	Local Const $EX_jump_alw = 'goto\(\d+\)'
	Local Const $EX_jump_alw_variable = 'goto\(' & $EX_VAR &'\)'
	Local Const $EX_jump_sle = 'sleep\(' & $EX_VAR & '\)'
	Local Const $EX_jump_stop = 'exit'
	Local Const $EX_jump_end = 'reset'
	Select
		Case Ex($aString[$i], $EX_jump_alw)
			$aString[$i] = 'jump ' & StringTrimBoth($aString[$i], 5, 1) & ' always 0 0'
		Case Ex($aString[$i], $EX_jump_alw_variable)
			$aString[$i] = 'set @counter ' & StringTrimBoth($aString[$i], 5, 1)
;~ 			ConsoleWrite($aString[$i] & @CRLF)
		Case Ex($aString[$i], $EX_jump_sle)
			$aString[$i] = 'wait ' & StringTrimBoth($aString[$i], 6, 1)
			Case Ex($aString[$i], $EX_jump_stop)
			$aString[$i] = 'stop'
		Case Ex($aString[$i], $EX_jump_end)
			$aString[$i] = 'end'
		Case Else
			$iRet = 0
	EndSelect
	Return $iRet
EndFunc   ;==>__Compile_Stage_1_InlineReplacements_Jump

Func __Compile_Stage_1_InlineReplacements_Jump(ByRef $aString, $i) ; Done
	Local $iRet = 1, $a
	Local Const $EX_jump_eq = 'if\(' & $EX_VAR & '=' & $EX_VAR & '\)goto\(\d+\)'
	Local Const $EX_jump_eq2 = 'if\(' & $EX_VAR & '==' & $EX_VAR & '\)goto\(\d+\)'
	Local Const $EX_jump_neq = 'if\(' & $EX_VAR & '!=' & $EX_VAR & '\)goto\(\d+\)'
	Local Const $EX_jump_neq2 = 'if\(' & $EX_VAR & '<>' & $EX_VAR & '\)goto\(\d+\)'
	Local Const $EX_jump_less = 'if\(' & $EX_VAR & '<' & $EX_VAR & '\)goto\(\d+\)'
	Local Const $EX_jump_leq = 'if\(' & $EX_VAR & '<=' & $EX_VAR & '\)goto\(\d+\)'
	Local Const $EX_jump_gr = 'if\(' & $EX_VAR & '>' & $EX_VAR & '\)goto\(\d+\)'
	Local Const $EX_jump_geq = 'if\(' & $EX_VAR & '>=' & $EX_VAR & '\)goto\(\d+\)'
	Select
		Case Ex($aString[$i], $EX_jump_eq)
			$a = Split($aString[$i], ')', '=', '(', 3, 1)
			$aString[$i] = 'jump ' & $a[3] & ' equal ' & $a[0] & ' ' & $a[1]
		Case Ex($aString[$i], $EX_jump_eq2)
			$a = Split($aString[$i], ')', '==', '(', 3, 1)
			$aString[$i] = 'jump ' & $a[3] & ' equal ' & $a[0] & ' ' & $a[1]
		Case Ex($aString[$i], $EX_jump_neq)
			$a = Split($aString[$i], ')', '!=', '(', 3, 1)
			$aString[$i] = 'jump ' & $a[3] & ' notEqual ' & $a[0] & ' ' & $a[1]
		Case Ex($aString[$i], $EX_jump_neq2)
			$a = Split($aString[$i], ')', '<>', '(', 3, 1)
			$aString[$i] = 'jump ' & $a[3] & ' notEqual ' & $a[0] & ' ' & $a[1]
		Case Ex($aString[$i], $EX_jump_less)
			$a = Split($aString[$i], ')', '<', '(', 3, 1)
			$aString[$i] = 'jump ' & $a[3] & ' lessThan ' & $a[0] & ' ' & $a[1]
		Case Ex($aString[$i], $EX_jump_leq)
			$a = Split($aString[$i], ')', '<=', '(', 3, 1)
			$aString[$i] = 'jump ' & $a[3] & ' lessThanEq ' & $a[0] & ' ' & $a[1]
		Case Ex($aString[$i], $EX_jump_gr)
			$a = Split($aString[$i], ')', '>', '(', 3, 1)
			$aString[$i] = 'jump ' & $a[3] & ' greaterThan ' & $a[0] & ' ' & $a[1]
		Case Ex($aString[$i], $EX_jump_geq)
			$a = Split($aString[$i], ')', '>=', '(', 3, 1)
			$aString[$i] = 'jump ' & $a[3] & ' greaterThanEq ' & $a[0] & ' ' & $a[1]
		Case Else
			$iRet = 0
	EndSelect
	Return $iRet
EndFunc   ;==>__Compile_Stage_1_InlineReplacements_Jump

Func __Compile_Stage_1_InlineReplacements_Control(ByRef $aString, $i) ; Done

	Local Static $REGEX = [ _
		Array(StringRegExpForCalls('enabled',    2), 'enabled',   2), _  ; enable(block)
		Array(StringRegExpForCalls('configure',  2), 'configure', 2), _  ; config(block, flag)
		Array(StringRegExpForCalls('lightcolor', 2), 'color',     2), _  ; lightcolor(illuminatorblock, color)
		Array(StringRegExpForCalls('shoot',      4), 'shoot',     4), _  ; shoot(block, x, y, shoot)
		Array(StringRegExpForCalls('shootp',     3), 'shootp',    3)], _ ; shootp(block, unit, shoot) priority?
	$PREFIX = 'control', $LEN = 5

	Local $iRet = 0, $aSplit, $iLen
	For $EX In $REGEX
		If StringRegExpMatchLine($aString[$i], $EX[0]) Then
			$aSplit = StringRegExpSplitLine($aString[$i], $EX[0])
			$aString[$i] = $PREFIX & ' ' & $EX[1] & ' '
			For $ii = 1 To $EX[2] Step 1
				$aString[$i] &= $aSplit[$ii] & ' '
			Next
			For $iii = $ii To $LEN - 1 Step 1
				$aString[$i] &= '0 '
			Next
			$aString[$i] = StringStripWS($aString[$i], 2)
			$iRet = 1
		EndIf
	Next

	Return $iRet
EndFunc   ;==>__Compile_Stage_1_InlineReplacements_Control

Func __Compile_Stage_1_InlineReplacements_Op(ByRef $aString, $i) ; Done
	Local $iRet = 1, $a, $s = $aString[$i]
	Local Static $aReplacementFunctions = [ _
			__Compile_Stage_1_InlineReplacements_Op_Trig, _
			__Compile_Stage_1_InlineReplacements_Op_Bitwise, _
			__Compile_Stage_1_InlineReplacements_Op_BasicArithmetic, _
			__Compile_Stage_1_InlineReplacements_Op_RelationAndLogic, _
			__Compile_Stage_1_InlineReplacements_Op_Functions, _
			__Compile_Stage_1_InlineReplacements_Op_IdivModPow]

	For $x In $aReplacementFunctions
		If $iRet = 1 Then $iRet += $x($aString, $i)
	Next
	If $aString[$i] = $s Then $iRet = 0
	Return $iRet
EndFunc   ;==>__Compile_Stage_1_InlineReplacements_Op

Func __Compile_Stage_1_InlineReplacements_Op_Functions(ByRef $aString, $i) ; Done
	Local $iRet = 1, $a, $s = $aString[$i]
	Local Static $EX_OP_MAX = StringRegExpForFunction('max', 2)     ; result = max(a, b)   -> result = größerer der beiden Werte
	Local Static $EX_OP_MIN = StringRegExpForFunction('min', 2)     ; result = min(a, b)   -> result = kleinerer der beiden Werte
	Local Static $EX_OP_LEN = StringRegExpForFunction('len', 2)     ; result = len(a, b)   -> result = sqrt(a^2+b^2)
	Local Static $EX_OP_ANG = StringRegExpForFunction('angle', 2)   ; result = angle(a, b) -> result = winkel für den Vektor (a,b)
	Local Static $EX_OP_NOI = StringRegExpForFunction('noise', 2)   ; result = noise(a, b) -> result = 2D-noise value
	Local Static $EX_OP_ABS = StringRegExpForFunction('abs', 1)     ; result = abs(a)      -> result = absolutwert von a
	Local Static $EX_OP_LOG = StringRegExpForFunction('log', 1)     ; result = log(a)      -> result = natürlicher log von a
	Local Static $EX_OP_L10 = StringRegExpForFunction('log10', 1)   ; result = log10(a)    -> result = zehnerlogarithmus von a
	Local Static $EX_OP_FLO = StringRegExpForFunction('floor', 1)   ; result = floor(a)    -> result = abgerundetes a
	Local Static $EX_OP_CEI = StringRegExpForFunction('ceiling', 1) ; result = ceiling(a)  -> result = aufgerundetes a
	Local Static $EX_OP_SQR = StringRegExpForFunction('sqrt', 1)    ; result = sqrt(a)     -> result = wurzel a
	Local Static $EX_OP_RND = StringRegExpForFunction('random', 1)  ; result = random(max) -> float zwischen  0  und max

	Select
		Case StringRegExpMatchLine($aString[$i], $EX_OP_MAX)
			$a = Split($aString[$i], '=', '', ',', 0, 1, 0, 0, 4)
			If UBound($a) = 3 Then $aString[$i] = 'op max ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case StringRegExpMatchLine($aString[$i], $EX_OP_MIN)
			$a = Split($aString[$i], '=', '', ',', 0, 1, 0, 0, 4)
			If UBound($a) = 3 Then $aString[$i] = 'op min ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case StringRegExpMatchLine($aString[$i], $EX_OP_LEN)
			$a = Split($aString[$i], '=', '', ',', 0, 1, 0, 0, 4)
			If UBound($a) = 3 Then $aString[$i] = 'op len ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case StringRegExpMatchLine($aString[$i], $EX_OP_ANG)
			$a = Split($aString[$i], '=', '', ',', 0, 1, 0, 0, 6)
			If UBound($a) = 3 Then $aString[$i] = 'op angle ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case StringRegExpMatchLine($aString[$i], $EX_OP_NOI)
			$a = Split($aString[$i], '=', '', ',', 0, 1, 0, 0, 6)
			If UBound($a) = 3 Then $aString[$i] = 'op noise ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case StringRegExpMatchLine($aString[$i], $EX_OP_ABS)
			$a = Split($aString[$i], '=', '', '', 0, 1, 0, 0, 4)
			If UBound($a) = 2 Then $aString[$i] = 'op abs ' & $a[0] & ' ' & $a[1] & ' 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_LOG)
			$a = Split($aString[$i], '=', '', '', 0, 1, 0, 0, 4)
			If UBound($a) = 2 Then $aString[$i] = 'op log ' & $a[0] & ' ' & $a[1] & ' 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_L10)
			$a = Split($aString[$i], '=', '', '', 0, 1, 0, 0, 6)
			If UBound($a) = 2 Then $aString[$i] = 'op log10 ' & $a[0] & ' ' & $a[1] & ' 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_FLO)
			$a = Split($aString[$i], '=', '', '', 0, 1, 0, 0, 6)
			If UBound($a) = 2 Then $aString[$i] = 'op floor ' & $a[0] & ' ' & $a[1] & ' 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_CEI)
			$a = Split($aString[$i], '=', '', '', 0, 1, 0, 0, 8)
			If UBound($a) = 2 Then $aString[$i] = 'op ceil ' & $a[0] & ' ' & $a[1] & ' 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_SQR)
			$a = Split($aString[$i], '=', '', '', 0, 1, 0, 0, 5)
			If UBound($a) = 2 Then $aString[$i] = 'op sqrt ' & $a[0] & ' ' & $a[1] & ' 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_RND)
			$a = Split($aString[$i], '=', '', '', 0, 1, 0, 0, 7)
			If UBound($a) = 2 Then $aString[$i] = 'op rand ' & $a[0] & ' ' & $a[1] & ' 0'
	EndSelect
	If $aString[$i] = $s Then $iRet = 0
	Return $iRet
EndFunc   ;==>__Compile_Stage_1_InlineReplacements_Op_Functions

Func __Compile_Stage_1_InlineReplacements_Draw(ByRef $aString, $i) ; Done
	Local $iRet = 1, $a, $s = $aString[$i]

	Local Static $EX_OP_CLE = StringRegExpForCalls('clear', 3)     ; clear(R, G, B)
	Local Static $EX_OP_REC = StringRegExpForCalls('rect', 4)      ; rect(x, y, w, h)
	Local Static $EX_OP_CO4 = StringRegExpForCalls('color', 4)     ; color(R, G, B, A)
	Local Static $EX_OP_CO1 = StringRegExpForCalls('color', 1)     ; color(#RRGGBBAA) -> col %RRGGBBAA 0 0 0 0 0
	Local Static $EX_OP_STR = StringRegExpForCalls('stroke', 1)    ; stroke(width)
	Local Static $EX_OP_LIN = StringRegExpForCalls('line', 4)      ; line(x1, y1, x2, y2)
	Local Static $EX_OP_LRE = StringRegExpForCalls('linerect', 4)  ; linerect(x, y, w, h)
	Local Static $EX_OP_PLY = StringRegExpForCalls('poly', 5)      ; poly(cx, cy, sides, radius, rotation)
	Local Static $EX_OP_LPY = StringRegExpForCalls('linepoly', 5)  ; linepoly(cx, cy, sides, radius, rotation)
	Local Static $EX_OP_TRI = StringRegExpForCalls('triangle', 6)  ; triangle(x1, y1, x2, y2, x3, y3)
	Local Static $EX_OP_IMA = StringRegExpForCalls('image', 5)     ; image(x, y, @image, ?, ?)
	Local Static $EX_OP_FLU = StringRegExpForCalls('drawflush', 1) ; drawflush(display1)

	Select
		Case StringRegExpMatchLine($aString[$i], $EX_OP_CLE)
			$a = StringSplit(StringTrimBoth($aString[$i], 6, 1), ',', 2)
			If UBound($a) = 3 Then $aString[$i] = 'draw clear ' & $a[0] & ' ' & $a[1] & ' ' & $a[2] & ' 0 0 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_REC)
			$a = StringSplit(StringTrimBoth($aString[$i], 5, 1), ',', 2)
			If UBound($a) = 4 Then $aString[$i] = 'draw rect ' & $a[0] & ' ' & $a[1] & ' ' & $a[2] & ' ' & $a[3] & ' 0 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_CO4)
			$a = StringSplit(StringTrimBoth($aString[$i], 6, 1), ',', 2)
			If UBound($a) = 4 Then $aString[$i] = 'draw color ' & $a[0] & ' ' & $a[1] & ' ' & $a[2] & ' ' & $a[3] & ' 0 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_CO1)
			$a = StringSplit(StringTrimBoth($aString[$i], 6, 1), ',', 2)
			If UBound($a) = 1 Then $aString[$i] = 'draw col ' & $a[0] & ' 0 0 0 0 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_STR)
			$a = StringTrimBoth($aString[$i], 7, 1)
			If $a <> '' Then $aString[$i] = 'draw stroke' & ' ' & $a & ' 0 0 0 0 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_LIN)
			$a = StringSplit(StringTrimBoth($aString[$i], 5, 1), ',', 2)
			If UBound($a) = 4 Then $aString[$i] = 'draw line ' & $a[0] & ' ' & $a[1] & ' ' & $a[2] & ' ' & $a[3] & ' 0 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_LRE)
			$a = StringSplit(StringTrimBoth($aString[$i], 9, 1), ',', 2)
			If UBound($a) = 4 Then $aString[$i] = 'draw lineRect ' & $a[0] & ' ' & $a[1] & ' ' & $a[2] & ' ' & $a[3] & ' 0 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_PLY)
			$a = StringSplit(StringTrimBoth($aString[$i], 5, 1), ',', 2)
			If UBound($a) = 5 Then $aString[$i] = 'draw poly ' & $a[0] & ' ' & $a[1] & ' ' & $a[2] & ' ' & $a[3] & ' ' & $a[4] & ' 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_LPY)
			$a = StringSplit(StringTrimBoth($aString[$i], 9, 1), ',', 2)
			If UBound($a) = 5 Then $aString[$i] = 'draw linePoly ' & $a[0] & ' ' & $a[1] & ' ' & $a[2] & ' ' & $a[3] & ' ' & $a[4] & ' 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_TRI)
			$a = StringSplit(StringTrimBoth($aString[$i], 9, 1), ',', 2)
			If UBound($a) = 6 Then $aString[$i] = 'draw triangle ' & $a[0] & ' ' & $a[1] & ' ' & $a[2] & ' ' & $a[3] & ' ' & $a[4] & ' ' & $a[5]
		Case StringRegExpMatchLine($aString[$i], $EX_OP_IMA)
			$a = StringSplit(StringTrimBoth($aString[$i], 6, 1), ',', 2)
			If UBound($a) = 5 Then $aString[$i] = 'draw image ' & $a[0] & ' ' & $a[1] & ' ' & $a[2] & ' ' & $a[3] & ' ' & $a[4] & ' 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_FLU)
			$a = StringTrimBoth($aString[$i], 10, 1)
			If $a <> '' Then $aString[$i] = 'drawflush' & ' ' & $a
		Case Else
			$iRet = 0
	EndSelect
	If $aString[$i] = $s Then $iRet = 0
	Return $iRet
EndFunc   ;==>__Compile_Stage_1_InlineReplacements_Draw

Func __Compile_Stage_1_InlineReplacements_Op_Trig(ByRef $aString, $i) ; Done
	Local $iRet = 1, $a, $s = $aString[$i]

	Local Static $EX_OP_SIN = StringRegExpForFunction('sin', 1)     ; result = sin(a)      ->
	Local Static $EX_OP_COS = StringRegExpForFunction('cos', 1)     ; result = cos(a, b)   ->
	Local Static $EX_OP_TAN = StringRegExpForFunction('tan', 1)     ; result = tan(a, b)   ->
	Local Static $EX_OP_AT2 = StringRegExpForFunction('atan2', 2)   ; result = atan2(a, b) ->

	Select
		Case StringRegExpMatchLine($aString[$i], $EX_OP_SIN)
			$a = Split($aString[$i], '(', '', '', 0, 1, 0, 4)
			If UBound($a) = 2 Then $aString[$i] = 'op sin ' & $a[0] & ' ' & $a[1] & ' 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_COS)
			$a = Split($aString[$i], '(', '', '', 0, 1, 0, 4)
			If UBound($a) = 2 Then $aString[$i] = 'op cos ' & $a[0] & ' ' & $a[1] & ' 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_TAN)
			$a = Split($aString[$i], '(', '', '', 0, 1, 0, 4)
			If UBound($a) = 2 Then $aString[$i] = 'op tan ' & $a[0] & ' ' & $a[1] & ' 0'
		Case StringRegExpMatchLine($aString[$i], $EX_OP_AT2)
			$a = Split($aString[$i], '(', '', ',', 0, 1, 0, 6)
			If UBound($a) = 3 Then $aString[$i] = 'op atan2 ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
	EndSelect
	If $aString[$i] = $s Then $iRet = 0
	Return $iRet
EndFunc   ;==>__Compile_Stage_1_InlineReplacements_Op_Trig


Func __Compile_Stage_1_InlineReplacements_Op_IdivModPow(ByRef $aString, $i) ; Done
	Local $iRet = 1, $a, $s = $aString[$i]


	; Instruktionstypen:
	; result [=] var1 [a][a] var2 -> [a] = sämtliche operatoren
	; var1 [a][a][=?] var2 -> sämtliche operatoren
	; hier muss was besseres her als aktuell...
	Local Static $K = $REGEX_OPTIONAL_PLUSMINUS & $EX_VAR

	Local Const $EX_op_idiv   = $EX_VAR & '=' & $K & '\/\%' & $K ; // (wurde durch %/ dargestellt)
	Local Const $EX_op_idiveq = $EX_VAR & '\/\%=' & $K
	Local Const $EX_op_mod    = $EX_VAR & '=' & $K & '\%' & $K
	Local Const $EX_op_modeq  = $EX_VAR & '\%=' & $K
	Local Const $EX_op_pow    = $EX_VAR & '=' & $K & '\*\*' & $K
	Local Const $EX_op_poweq  = $EX_VAR & '\*\*=' & $K
	Select
		Case StringRegExpMatchLine($aString[$i], $EX_op_idiv)
			$a = Split($aString[$i], '=', '', '/%')
			If UBound($a) = 3 Then $aString[$i] = 'op idiv' & ' ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case StringRegExpMatchLine($aString[$i], $EX_op_idiveq)
			$a = StringSplit($aString[$i], '/%=', 3)
			If UBound($a) = 2 Then $aString[$i] = 'op idiv' & ' ' & $a[0] & ' ' & $a[0] & ' ' & $a[1]
		Case StringRegExpMatchLine($aString[$i], $EX_op_mod)
			$a = Split($aString[$i], '=', '', '%')
			If UBound($a) = 3 Then $aString[$i] = 'op mod' & ' ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case StringRegExpMatchLine($aString[$i], $EX_op_modeq)
			$a = StringSplit($aString[$i], '%=', 3)
			If UBound($a) = 2 Then $aString[$i] = 'op mod' & ' ' & $a[0] & ' ' & $a[0] & ' ' & $a[1]
		Case StringRegExpMatchLine($aString[$i], $EX_op_pow)
			$a = Split($aString[$i], '=', '', '**')
			If UBound($a) = 3 Then $aString[$i] = 'op pow' & ' ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case StringRegExpMatchLine($aString[$i], $EX_op_poweq)
			$a = StringSplit($aString[$i], '**=', 3)
			If UBound($a) = 2 Then $aString[$i] = 'op pow' & ' ' & $a[0] & ' ' & $a[0] & ' ' & $a[1]
	EndSelect
	If $aString[$i] = $s Then $iRet = 0
	Return $iRet
EndFunc

Func __Compile_Stage_1_InlineReplacements_Op_Bitwise(ByRef $aString, $i) ; Done
	Local $iRet = 1, $a, $s = $aString[$i]
	Local Static $K = $REGEX_OPTIONAL_PLUSMINUS & $EX_VAR
	Local Const $EX_op_bshl = $EX_VAR & '=' & $K & '<<' & $K ; <<    -> op shl result null true
	Local Const $EX_op_bshr = $EX_VAR & '=' & $K & '>>' & $K ; >>    -> op shr result null true
	Local Const $EX_op_band = $EX_VAR & '=' & $K & '\&' & $K ; b-and -> op and result a b
	Local Const $EX_op_bor = $EX_VAR & '=' & $K & '\|' & $K ; or    -> op or result a b
	Local Const $EX_op_bxor = $EX_VAR & '=' & $K & '\^' & $K ; xor   -> op xor result a b
	Local Const $EX_op_bnot = $EX_VAR & '=\~' & $K   ; flip  -> op not result "a" 0
	Select
		Case Ex($aString[$i], $EX_op_bshl)
			$a = Split($aString[$i], '=', '', '<<')
			If UBound($a) = 3 Then $aString[$i] = 'op shl ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_bshr)
			$a = Split($aString[$i], '=', '', '>>')
			If UBound($a) = 3 Then $aString[$i] = 'op shr ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_band)
			$a = Split($aString[$i], '=', '', '&')
			If UBound($a) = 3 Then $aString[$i] = 'op and ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_bor)
			$a = Split($aString[$i], '=', '', '|')
			If UBound($a) = 3 Then $aString[$i] = 'op or ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_bxor)
			$a = Split($aString[$i], '=', '', '^')
			If UBound($a) = 3 Then $aString[$i] = 'op xor ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_bnot)
			$a = Split($aString[$i], '=~')
			If UBound($a) = 2 Then $aString[$i] = 'op not ' & $a[0] & ' ' & $a[1] & ' 0'
	EndSelect
	If $aString[$i] = $s Then $iRet = 0
	Return $iRet
EndFunc   ;==>__Compile_Stage_1_InlineReplacements_Op_Bitwise

Func __Compile_Stage_1_InlineReplacements_Op_BasicArithmetic(ByRef $aString, $i) ; Done
	Local $iRet = 1, $a, $s = $aString[$i]
	Local Static $K = $REGEX_OPTIONAL_PLUSMINUS & $EX_VAR
	Local Const $EX_op_add = $EX_VAR & '=' & $K & '\+' & $K
	Local Const $EX_op_addeq = $EX_VAR & '\+=' & $K
	Local Const $EX_op_inc = $EX_VAR & '\+{2}'
	Local Const $EX_op_sub = $EX_VAR & '=' & $K & '\-' & $K
	Local Const $EX_op_subeq = $EX_VAR & '\-=' & $K
	Local Const $EX_op_dec = $EX_VAR & '\-{2}'
	Local Const $EX_op_mul = $EX_VAR & '=' & $K & '\*' & $K
	Local Const $EX_op_muleq = $EX_VAR & '\*=' & $K
	Local Const $EX_op_div = $EX_VAR & '=' & $K & '\/' & $K
	Local Const $EX_op_diveq = $EX_VAR & '\/=' & $K
	Select
		Case Ex($aString[$i], $EX_op_add)
			$a = Split($aString[$i], '=', '', '+')
			If UBound($a) = 3 Then $aString[$i] = 'op add' & ' ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_addeq)
			$a = StringSplit($aString[$i], '+=', 3)
			If UBound($a) = 2 Then $aString[$i] = 'op add' & ' ' & $a[0] & ' ' & $a[0] & ' ' & $a[1]
		Case Ex($aString[$i], $EX_op_inc)
			$a = StringTrimRight($aString[$i], 2)
			If $a <> '' Then $aString[$i] = 'op add' & ' ' & $a & ' ' & $a & ' ' & 1
		Case Ex($aString[$i], $EX_op_sub)
			$a = Split($aString[$i], '=', '', '-')
			If UBound($a) = 3 Then $aString[$i] = 'op sub' & ' ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_subeq)
			$a = StringSplit($aString[$i], '-=', 3)
			If UBound($a) = 2 Then $aString[$i] = 'op sub' & ' ' & $a[0] & ' ' & $a[0] & ' ' & $a[1]
		Case Ex($aString[$i], $EX_op_dec)
			$a = StringTrimRight($aString[$i], 2)
			If $a <> '' Then $aString[$i] = 'op sub' & ' ' & $a & ' ' & $a & ' ' & 1
		Case Ex($aString[$i], $EX_op_mul)
			$a = Split($aString[$i], '=', '', '*')
			If UBound($a) = 3 Then $aString[$i] = 'op mul' & ' ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_muleq)
			$a = StringSplit($aString[$i], '*=', 3)
			If UBound($a) = 2 Then $aString[$i] = 'op mul' & ' ' & $a[0] & ' ' & $a[0] & ' ' & $a[1]
		Case Ex($aString[$i], $EX_op_div)
			$a = Split($aString[$i], '=', '', '/')
			If UBound($a) = 3 Then $aString[$i] = 'op div' & ' ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_diveq)
			$a = StringSplit($aString[$i], '/=', 3)
			If UBound($a) = 2 Then $aString[$i] = 'op div' & ' ' & $a[0] & ' ' & $a[0] & ' ' & $a[1]
	EndSelect
	If $aString[$i] = $s Then $iRet = 0
	Return $iRet
EndFunc   ;==>__Compile_Stage_1_InlineReplacements_Op_BasicArithmetic

Func __Compile_Stage_1_InlineReplacements_Op_RelationAndLogic(ByRef $aString, $i) ; Done
	Local $iRet = 1, $a, $s = $aString[$i]
	Local Static $K = $REGEX_OPTIONAL_PLUSMINUS & $EX_VAR
	Local Const $EX_op_land = $EX_VAR & '=' & $K & '\&\&' & $K ; result = a && b -> op land result a b (logical and)
	Local Const $EX_op_lor = $EX_VAR & '=' & $K & '\|\|' & $K ; result = a || b -> op or result a b (logical or, same as bitwise or)
	Local Const $EX_op_lnot = $EX_VAR & '=\!' & $K      ; result = !b     -> op ???? result ? ? (logical and, same as bitwise not)
	Local Const $EX_op_equal = $EX_VAR & '=' & $K & '={2}' & $K ; result = a == b -> op equal result a b
	Local Const $EX_op_squal = $EX_VAR & '=' & $K & '={3}' & $K ; result = a === b -> op strictEqual result a b
	Local Const $EX_op_neq = $EX_VAR & '=' & $K & '\<\>' & $K ; result = a != b -> op notEqual result a b
	Local Const $EX_op_neq2 = $EX_VAR & '=' & $K & '\!\=' & $K ; result = a <> b -> op notEqual result a b
	Local Const $EX_op_less = $EX_VAR & '=' & $K & '\<' & $K ; result = a < b  -> op ??? a b
	Local Const $EX_op_leq = $EX_VAR & '=' & $K & '\<\=' & $K ; result = a <= b -> op ??? a b
	Local Const $EX_op_gr = $EX_VAR & '=' & $K & '\>' & $K ; result = a > b  -> op ??? a b
	Local Const $EX_op_geq = $EX_VAR & '=' & $K & '\>\=' & $K ; result = a >= b -> op ??? a b
	Select
		Case Ex($aString[$i], $EX_op_land)
			$a = Split($aString[$i], '=', '', '&&')
			If UBound($a) = 3 Then $aString[$i] = 'op land ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_lor)
			$a = Split($aString[$i], '=', '', '||')
			If UBound($a) = 3 Then $aString[$i] = 'op or ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_lnot)
			$a = Split($aString[$i], '=!')
			If UBound($a) = 2 Then $aString[$i] = 'op not ' & $a[0] & ' ' & $a[1] & ' 0'
		Case Ex($aString[$i], $EX_op_equal)
			$a = Split($aString[$i], '==', '=', '')
			If UBound($a) = 3 Then $aString[$i] = 'op equal ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_squal)
			$a = Split($aString[$i], '===', '=', '')
			If UBound($a) = 3 Then $aString[$i] = 'op strictEqual ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_neq)
			$a = Split($aString[$i], '=', '', '<>')
			If UBound($a) = 3 Then $aString[$i] = 'op notEqual ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_neq2)
			$a = Split($aString[$i], '!=', '=', '')
			If UBound($a) = 3 Then $aString[$i] = 'op notEqual ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_less)
			$a = Split($aString[$i], '=', '', '<')
			If UBound($a) = 3 Then $aString[$i] = 'op lessThan ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_leq)
			$a = Split($aString[$i], '<=', '=', '')
			If UBound($a) = 3 Then $aString[$i] = 'op lessThanEq ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_gr)
			$a = Split($aString[$i], '=', '', '>')
			If UBound($a) = 3 Then $aString[$i] = 'op greaterThan ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
		Case Ex($aString[$i], $EX_op_geq)
			$a = Split($aString[$i], '>=', '=', '')
			If UBound($a) = 3 Then $aString[$i] = 'op greaterThanEq ' & $a[0] & ' ' & $a[1] & ' ' & $a[2]
	EndSelect
	If $aString[$i] = $s Then $iRet = 0
	Return $iRet
EndFunc   ;==>__Compile_Stage_1_InlineReplacements_Op_RelationAndLogic

Func __Compile_Stage_1_InlineReplacements_Radar(ByRef $aString, $i) ; TODO
	Local $iRet = 0
	Return $iRet
EndFunc   ;==>__Compile_Stage_1_InlineReplacements_Radar

Func __Compile_Stage_1_InlineReplacements_Unit(ByRef $aString, $i) ; TODO
	Local $iRet = 0
	Return $iRet
EndFunc   ;==>__Compile_Stage_1_InlineReplacements_Unit
