#include-once
#include '../Util.au3'

Func _Compile_Stage_0(ByRef $sString)
	_Compile_Stage_0_InlineRenames($sString)
	_Compile_Stage_0_AddEOFIfNeeded($sString)
EndFunc

Func _Compile_Stage_0_InlineRenames(ByRef $sString)	; Weil Minusse in Variablennamen nicht erlaubt sein sollten...
	$sString = StringReplace($sString, '@phasefabric'  , '@phase-fabric')
	$sString = StringReplace($sString, '@surgealloy'   , '@surge-alloy')
	$sString = StringReplace($sString, '@sporepod'     , '@spore-pod')
	$sString = StringReplace($sString, '@blastcompound', '@blast-compound')
EndFunc

Func _Compile_Stage_0_AddEOFIfNeeded(ByRef $sString)
	Local $aString = StringSplit($sString, @CRLF, 3), $u = UBound($aString), $bAdd = False, $a, $b, $sRet = ''
	For $i = 0 To $u - 1 Step 1
		If StringLeftEquals($aString[$i], 'jump') Then
			$a = Number(StringSplit($aString[$i], ' ', 2)[1])
			If $a > $u Then
				ErrorPush(0, $i, $aString[$i], 1, 'Jump destination > codelength', 'Set jump destination to EOF (' & $u & ')')
				$a = $u
				$b = StringSplit($aString[$i], ' ', 2)
				$aString[$i] = $b[0] & ' ' & $a & ' ' & $b[2] & ' ' & $b[3] & ' ' & $b[4]
			ElseIf $a < 0 Then
				ErrorPush(0, $i, $aString[$i], 1, 'Jump destination < 0', 'Set jump destination to 0')
				$a = 0
				$b = StringSplit($aString[$i], ' ', 2)
				$aString[$i] = $b[0] & ' ' & $a & ' ' & $b[2] & ' ' & $b[3] & ' ' & $b[4]
			EndIf
			If $a = $u Then $bAdd = True
		EndIf
		$sRet &= $aString[$i] & @CRLF
	Next
	$sString = StringTrimRight($sRet, 2) & ($bAdd ? (@CRLF & 'end') : (''))
EndFunc
