#include-once
#include '../Util.au3'

; Wrapper der die Syntax ein bisschen umbaut.
; Alles hier ist 1 zu 1 identisch zu Mindustry Logic (z.B. aus a = Random(5) wird op rand a 5 0 0 0 und so)
; Neue funktionen gibts hier noch nicht.

Func _Compile1(ByRef $sString)
	Local $aString = StringSplit($sString, @CRLF, 3), $sRet = ''
	Local Static $REPLACE = [ _
	__Compile1_Call, _
	__Compile1_Func, _
	__Compile1_Equality, _
	__Compile1_Modification, _
	__Compile1_JumpIf, _
	__Compile1_Other]

	Local $n = 0
	For $i = 0 To UBound($aString) - 1 Step 1
		If Not $aString[$i] Then ContinueLoop
		$n = 0
		For $x In $REPLACE
			If $n = 0 Then $n += $x($aString[$i])
		Next
		If $n = 0 Then ErrorPush(1, $i, $aString[$i], 1, 'could not translate this')
		$sRet &= $aString[$i] & @CRLF
	Next
	$sString = StringTrimRight($sRet, 2)
EndFunc

;~ ; __Compile1_JumpIf
;~ if (a=5)  goto(dst)
;~ if (5=a)  goto(55)
;~ if (a==b) goto(c)
;~ if (a!=5) goto(5)
;~ if (a<>5) goto(_underscore)
;~ if (a<5)  goto(45)
;~ if (5>a)  goto(45)
;~ if (a<=b) goto(c)
;~ if (a>=b) goto(d)

Func __Compile1_JumpIf(ByRef $sLine)

	Local Static $MATCH = [ _	; if(...)goto(int)
		['=',  'equal'   ], _
		['==', 'equal'], _
		['!=', 'notEqual'], _
		['<>', 'notEqual'], _
		['<', 'lessThan'], _
		['<=', 'lessThanEq'], _
		['>', 'greaterThan'], _
		['>=', 'greaterThanEq'] _
		]

	Local $iRet = 0
	If StringRegExpMatchLine($sLine, $EX_ANYJUMPIF) Then
		Local $aSplit = StringRegExpSplitLine($sLine, $EX_ANYJUMPIF) ; if ([0] [1] [2])goto([4])
		For $i = 0 To UBound($MATCH) - 1 Step 1
			If $aSplit[1] = $MATCH[$i][0] Then
				$sLine = 'jump ' & $aSplit[4] & ' ' & $MATCH[$i][1] & ' ' & $aSplit[0] & ' ' & $aSplit[2]
				$iRet = 1
				ExitLoop
			EndIf
		Next
	EndIf

	Return $iRet
EndFunc


;~ ; __Compile1_Other
;~ exit
;~ reset
;~ a++
;~ ; 5++ soll einen Error ergeben.
;~ b--
;~ goto(100)
;~ goto(var)

Func __Compile1_Other(ByRef $sLine)

	Local $iRet = 0
	Switch $sLine
		Case 'exit'
			$sLine = 'stop'
			$iRet = 1
		Case 'reset'
			$sLine = 'end'
			$iRet = 1
		Case Else
			Select
				Case StringRegExpMatchLine($sLine, $EX_ANYINCDEC)
					Local $aSplit = StringRegExpSplitLine($sLine, $EX_ANYINCDEC)
					Switch $aSplit[1]
						Case '--'
							$sLine = 'op sub ' & $aSplit[0] & ' ' & $aSplit[0] & ' 1'
							$iRet = 1
						Case '++'
							$sLine = 'op add ' & $aSplit[0] & ' ' & $aSplit[0] & ' 1'
							$iRet = 1
					EndSwitch
				Case StringRegExpMatchLine($sLine, $EX_GOTOINTVAR) ; goto(integer), goto(var)
					Local $aSplit = StringRegExpSplitLine($sLine, $EX_GOTOINTVAR)
					If StringIsInt($aSplit[1]) Then
						$sLine = 'jump ' & $aSplit[1] & ' always 0 0'
					Else
						$sLine = 'set @counter ' & $aSplit[1]
					EndIf
					$iRet = 1
			EndSelect
	EndSwitch

	Return $iRet
EndFunc

Func __Compile1_Modification(ByRef $sLine)

	Local Static $MATCH = [ _	; var1 ... var2 -> op var1 var1 var2
		['=',  'set'   ], _
		['+=', 'op add'], _
		['-=', 'op sub'], _
		['*=', 'op mul'], _
		['/=', 'op div'], _
		['^=', 'op pow'], _
		['%=', 'op mod'], _
		['//=', 'op idiv'] _
		]

	Local $iRet = 0
	If StringRegExpMatchLine($sLine, $EX_ANYMODIFY) Then
		Local $aSplit = StringRegExpSplitLine($sLine, $EX_ANYMODIFY)
		For $i = 0 To UBound($MATCH) - 1 Step 1
			If $aSplit[1] = $MATCH[$i][0] Then
				If $aSplit[1] = '=' Then
					$sLine = $MATCH[$i][1] & ' ' & $aSplit[0] & ' ' & $aSplit[2] ; var = varornumber
				Else
					$sLine = $MATCH[$i][1] & ' ' & $aSplit[0] & ' ' & $aSplit[0] & ' ' & $aSplit[2] ; var op= varornumber
				EndIf
				$iRet = 1
				ExitLoop
			EndIf
		Next
	EndIf

	Return $iRet
EndFunc

Func __Compile1_Equality(ByRef $sLine)

	Local Static $MATCH = [ _	; var1 = var2 ... var3 -> op var1 var2 var3
		['+', 'op add'], _
		['-', 'op sub'], _
		['*', 'op mul'], _
		['/', 'op div'], _
		['^', 'op pow'], _
		['%', 'op mod'], _
		['=', 'op equal'], _
		['<', 'op lessthan'], _
		['>', 'op greaterthan'], _
		['==', 'op strictequal'], _
		['!=', 'op notequal'], _
		['<>', 'op notequal'], _
		['<=', 'op lessthaneq'], _
		['>=', 'op greaterthaneq'], _
		['//', 'op idiv'] _ ; integer division
		]

	; var1 = [+-]varornumber2 ... [+-]varornumber3
	; Forbidden is: variablen mit vorzeichen (egal ob + oder -)
	; zB. a = -b + c
	; Diese Funktion hier verarbeitet nur valide inputs

	Local $iRet = 0
	If StringRegExpMatchLine($sLine, $EX_ANYEQUALITY) Then
		Local $aSplit = StringRegExpSplitLine($sLine, $EX_ANYEQUALITY) ; [0] = result, [1] = var1, [2] = operatoren, [3] = var2
		For $i = 0 To UBound($MATCH) - 1 Step 1
			If $aSplit[2] = $MATCH[$i][0] Then
				$sLine = $MATCH[$i][1] & ' ' & $aSplit[0] & ' ' & $aSplit[1] & ' ' & $aSplit[3]
				$iRet = 1
				ExitLoop
			EndIf
		Next
	EndIf

	Return $iRet
EndFunc

Func __Compile1_Func(ByRef $sLine)

	Local Static $MATCH = [ _ ; var = func(...)
		['and',     'op land',  Array(0, 1, 2), 2], _ ; result = and(a, b)
		['or',      'op or',    Array(0, 1, 2), 2], _ ; result = or(a, b), identisch zu bitor
		['read',    'read',     Array(0, 1, 2), 2], _ ; result = read(cell1, index) -> liest einen Wert aus einer Speicherzelle
		['sensor',  'sensor',   Array(0, 1, 2), 2], _ ; result = sensor(block1, @copper)      -> liest wie viel z.B. @copper innerhalb von block1 ist
		['getlink', 'getlink',  Array(0, 1   ), 1], _ ; result = getlink(n)      -> gibt das verbundene Gebäude mit nummer N zurück
		['bitor',   'op or',    Array(0, 1, 2), 2], _ ; result = bitor(a, b)       ->
		['bitand',  'op and',   Array(0, 1, 2), 2], _ ; result = bitand(a, b)      ->
		['bitxor',  'op xor',   Array(0, 1, 2), 2], _ ; result = bitxor(a, b)      ->
		['bitnot',  'op not',   Array(0, 1, 0), 1], _ ; result = bitnot(a)         ->
		['bitshl',  'op shl',   Array(0, 1, 2), 2], _ ; result = bitshiftl(a, len) ->
		['bitshr',  'op shr',   Array(0, 1, 2), 2], _ ; result = bitshiftr(a, len) ->
		['sin',     'op sin',   Array(0, 1, 0), 1], _ ; result = sin(a)            ->
		['cos',     'op cos',   Array(0, 1, 0), 1], _ ; result = cos(a)            ->
		['tan',     'op tan',   Array(0, 1, 0), 1], _ ; result = tan(a)            ->
		['asin',    'op asin',  Array(0, 1, 0), 1], _ ; result = asin(a)           ->
		['acos',    'op acos',  Array(0, 1, 0), 1], _ ; result = acos(a)           ->
		['atan',    'op atan',  Array(0, 1, 0), 1], _ ; result = atan(a)           ->
		['atan2',   'op angle', Array(0, 1, 2), 2], _ ; result = atan2(a, b) -> siehe angle
		['max',     'op max',   Array(0, 1, 2), 2], _ ; result = max(a, b)   -> result = größerer der beiden Werte
		['min',     'op min',   Array(0, 1, 2), 2], _ ; result = min(a, b)   -> result = kleinerer der beiden Werte
		['angle',   'op angle', Array(0, 1, 2), 2], _ ; result = angle(a, b) -> result = winkel für den Vektor (a,b) = atan2
		['len',     'op len',   Array(0, 1, 2), 2], _ ; result = len(a, b)   -> result = sqrt(a^2+b^2)
		['noise',   'op noise', Array(0, 1, 2), 2], _ ; result = noise(a, b) -> result = 2D-noise value
		['abs',     'op abs',   Array(0, 1, 0), 1], _ ; result = abs(a)      -> result = absolutwert von a
		['log',     'op log',   Array(0, 1, 0), 1], _ ; result = log(a)      -> result = natürlicher log von a
		['log10',   'op log10', Array(0, 1, 0), 1], _ ; result = log10(a)    -> result = zehnerlogarithmus von a
		['floor',   'op floor', Array(0, 1, 0), 1], _ ; result = floor(a)    -> result = abgerundetes a
		['ceiling', 'op ceil',  Array(0, 1, 0), 1], _ ; result = ceiling(a)  -> result = aufgerundetes a
		['sqrt',    'op sqrt',  Array(0, 1, 0), 1], _ ; result = sqrt(a)     -> result = wurzel a
		['random',  'op rand',  Array(0, 1, 0), 1] _  ; result = random(max) -> float zwischen 0 und max
		]

	Local $iRet = 0
	If StringRegExpMatchLine($sLine, $EX_ANYFUNC) Then ; var = function(???), matches anything that looks like that.
		Local $aSplit = StringRegExpSplitLine($sLine, $EX_ANYFUNC)
		Local $aParam = StringSplitParams($aSplit[2])
		For $i = 0 To UBound($MATCH) - 1 Step 1
			If $aSplit[1] = $MATCH[$i][0] And UBound($aParam) = $MATCH[$i][3] Then
				Local $_ = $MATCH[$i][2], $n = 0 ; [0, 0, 0, 0, 0, ...]
				$_[0] = $aSplit[0]
				For $ii = 0 To UBound($aParam) - 1 Step 1
					$_[$ii + 1] = $aParam[$ii]
				Next
				$sLine = $MATCH[$i][1] & ' '
				For $ii = 0 To UBound($_) - 1 Step 1
					$sLine &= $_[$ii] & ' '
				Next
				$sLine = StringStripWS($sLine, 2)
				$iRet = 1
				ExitLoop
			EndIf
		Next
	EndIf

	Return $iRet
EndFunc

Func __Compile1_Call(ByRef $sLine)

	Local Static $MATCH = [ _ ; func(...)
		['lightcolor', 'control color',   Array(1, 2, 0, 0, 0   ), 2], _ ; lightcolor(illuminatorblock, flag)
		['printflush', 'printflush',      Array(1               ), 1], _ ; printflush(block)
		['drawflush',  'drawflush',       Array(1               ), 1], _ ; drawflush(block)
		['linepoly',   'draw linepoly',   Array(1, 2, 3, 4, 5, 0), 5], _ ; linepoly(centerX, centerY, numSides, radius, rotation)
		['triangle',   'draw triangle',   Array(1, 2, 3, 4, 5, 6), 6], _ ; triangle(x1, y1, x2, y2, x3, y3)
		['linerect',   'draw linerect',   Array(1, 2, 3, 4, 0, 0), 4], _ ; linerect(x, y, w, h)
		['enabled',    'control enabled', Array(1, 2, 0, 0, 0   ), 2], _ ; enabled(block, flag)
		['shootp',     'control shootp',  Array(1, 2, 3, 0, 0   ), 3], _ ; shootp(block, unit, shoot) p = priority?
		['config',     'control config',  Array(1, 2, 0, 0, 0   ), 2], _ ; config(block, flag)
		['stroke',     'draw stroke',     Array(1, 0, 0, 0, 0, 0), 1], _ ; stroke(width)
		['shoot',      'control shoot',   Array(1, 2, 3, 4, 0   ), 4], _ ; shoot(block, x, y, shoot)
		['print',      'print',           Array(1               ), 1], _ ; print(var or string)
		['write',      'write',           Array(1, 2, 3         ), 3], _ ; write(value, block, index)
		['clear',      'draw clear',      Array(1, 2, 3, 0, 0, 0), 3], _ ; clear(R, G, B)
		['color',      'draw color',      Array(1, 2, 3, 4, 0, 0), 4], _ ; color(R, G, B, A)
		['color',      'draw col',        Array(1, 0, 0, 0, 0, 0), 1], _ ; color(%RRGGBBAA)
		['image',      'draw image',      Array(1, 2, 3, 4, 5, 0), 5], _ ; image(x, y, @image, sizePx, rotation)
		['sleep',      'wait',            Array(1               ), 1], _ ; sleep(duration in seconds)
		['line',       'draw line',       Array(1, 2, 3, 4, 0, 0), 4], _ ; line(x1, y1, x2, y2)
		['rect',       'draw rect',       Array(1, 2, 3, 4, 0, 0), 4], _ ; rect(x, y, w, h)
		['poly',       'draw poly',       Array(1, 2, 3, 4, 5, 0), 5] _ ; poly(centerX, centerY, numSides, radius, rotation)
		]

	Local $iRet = 0
	If StringRegExpMatchLine($sLine, $EX_ANYCALL) Then ; var = function(???), matches anything that looks like that.
		Local $aSplit = StringRegExpSplitLine($sLine, $EX_ANYCALL)
		Local $aParam = StringSplitParams($aSplit[1])
		For $i = 0 To UBound($MATCH) - 1 Step 1
			If $aSplit[0] = $MATCH[$i][0] And (UBound($aParam) = $MATCH[$i][3]) Then
				Local $_ = $MATCH[$i][2] ; [0, ...]
				For $ii = 0 To UBound($aParam) - 1 Step 1
					$_[$ii] = $aParam[$ii]
				Next
				$sLine = $MATCH[$i][1] & ' '
				For $ii = 0 To UBound($_) - 1 Step 1
					$sLine &= $_[$ii] & ' '
				Next
				$sLine = StringStripWS($sLine, 2)
				$iRet = 1
				ExitLoop
			EndIf
		Next
	EndIf

	Return $iRet
EndFunc



Func __Compile_Stage_1_InlineReplacements_Radar(ByRef $sLine) ; TODO
	Local $iRet = 0
	Return $iRet
EndFunc   ;==>__Compile_Stage_1_InlineReplacements_Radar

Func __Compile_Stage_1_InlineReplacements_Unit(ByRef $sLine) ; TODO
	Local $iRet = 0
	Return $iRet
EndFunc   ;==>__Compile_Stage_1_InlineReplacements_Unit
