#include-once
#include '../Util.au3'

; Fügt labels hinzu
; Alles was Labels nutzt muss in Stage3 oder höher!

Func _Compile_Stage_2(ByRef $sString)
	Local $aString = StringSplit($sString, @CRLF, 3), $sRet = ''
	Local $aLabels = __Compile_Stage_2_Labels__GetLabels($aString)
	For $i = 0 To UBound($aString) - 1 Step 1
		If Not $aString[$i] Then ContinueLoop
		For $ii = 0 To UBound($aLabels) - 1 Step 1
			If StringInStr($aString[$i], $aLabels[$ii][0], 0, 1) Then
				$aString[$i] = StringReplace($aString[$i], $aLabels[$ii][0], $aLabels[$ii][1])
				__Compile_Stage_2_Labels__Arithmetik($aString, $i, '+')
				__Compile_Stage_2_Labels__Arithmetik($aString, $i, '-')
			EndIf
		Next
		$sRet &= $aString[$i] & @CRLF
	Next
	__Compile_Stage_2_Labels__ErrorForUnresolvedLabels($sRet)
	__Compile_Stage_2_Labels__ThisLineMakro($sRet)
	$sString = StringStripWS($sRet, 2)
EndFunc

Func __Compile_Stage_2_Labels__ThisLineMakro(ByRef $sString)
	Local $aString = StringSplit($sString, @CRLF, 3), $sRet = ''
	For $i = 0 To UBound($aString) - 1 Step 1
		$aString[$i] = StringReplace($aString[$i], $SYNTAX_MACRO_LINE, $i)
		$sRet &= $aString[$i] & @CRLF
	Next
	$sString = $sRet
EndFunc   ;==>__Compile_Stage_2_Labels__ThisLineMakro

Func __Compile_Stage_2_Labels__GetLabels(ByRef $aString)
	Local $aRet[0][2]
	For $i = 0 To UBound($aString) - 1 Step 1
		If Not $aString[$i] Then ContinueLoop
		Select
			Case StringRegExpMatchLine($aString[$i], $EX_LABEL)
				ArrayPush($aRet, Array($aString[$i], $i - UBound($aRet)))
				$aString[$i] = ''
		EndSelect
	Next
	Return $aRet
EndFunc   ;==>__Compile_Stage_2_Labels__GetLabels

Func __Compile_Stage_2_Labels__Arithmetik(ByRef $aString, $i, $sPlusMinus)
	Local $a, $s = $aString[$i]
	If StringInStr($aString[$i], $sPlusMinus, 0, 1) Then
		$a = StringSplit($aString[$i], '(')
		$aString[$i] = ''
		For $j = 1 To $a[0] - 1 Step 1
			$aString[$i] &= $a[$j] & '('
		Next
		$a = StringSplit(StringTrimRight($a[$a[0]], 1), $sPlusMinus, 3)
		$b = $a[0] + $a[1] * ($sPlusMinus = '-' ? -1 : 1)
		If $b < 0 Then
			ErrorPush(2, $i, $s, 1, 'Jump destination < 0', 'set jump destination to 0')
			$b = 0
		EndIf
		$aString[$i] &= $b & ')'
	EndIf
EndFunc   ;==>__Compile_Stage_2_Labels__Arithmetik

Func __Compile_Stage_2_Labels__ErrorForUnresolvedLabels(ByRef $sString)
	Local $aString = StringSplit($sString, @CRLF, 3)
	For $i = 0 To UBound($aString) - 1 Step 1
		If StringRegExp($aString[$i], $EX_LABEL) Then
			ErrorPush(2, $i, $aString[$i], 2, 'Unresolved label')
		EndIf
	Next
EndFunc   ;==>__Compile_Stage_2_Labels__ErrorForUnresolvedLabels
