#include-once
#include '../Util.au3'

; Flow


Func _Compile3(ByRef $sString)

	$sString = _Compile_Stage_3_Subroutine_noParam_noReturn($sString)
	$sString = _Compile_Stage_3b_Subroutine_noParam_noReturn_Call($sString)

	$sString = _Compile_Stage_3b_If($sString) ; Behandelt [If(varornumber operatoren varornumber) \n ... \n [optional else] \n ... \n endif], ohne etwas dahinter
	$sString = _Compile_Stage_3_For($sString)
	$sString = _Compile_Stage_3b_ExitloopContinueLoop($sString)

EndFunc

Func _Compile_Stage_3b_Subroutine_noParam_noReturn_Call(ByRef $sString)
	Local $aString = StringSplit($sString, @CRLF, 3), $sRet = '', $s = ''
	Local $x = ''
	For $i = 0 To UBound($aString) - 1 Step 1
		$s = $aString[$i]
		Select
			Case Ex($aString[$i], $EX_ANY_CALL0)
				$x = StringTrimRight($aString[$i], StringLen('()'))
;~ 				ConsoleWrite('sub: ' & $i & ': ' & $s & '-> name = ' & $x & @CRLF)
				$aString[$i] = _
				$VAR_SUB_RETURNPOINTER & $x & '='&$SYNTAX_MACRO_LINE&'+2' & @CRLF & _
				'goto(' & $LABEL_SUB_START & $x & ')'
		EndSelect
		$sRet &= $aString[$i] & @CRLF
	Next
	Return StringTrimRight($sRet, 2)
EndFunc

Func _Compile_Stage_3_Subroutine_noParam_noReturn(ByRef $sString)
	Local $aString = StringSplit($sString, @CRLF, 3), $sRet = '', $s = ''
	Local Const $EX_sub_start    = 'sub ' & $EX_VAR & '\(\)' ; ohne Parameter
	Local Const $EX_sub_end      = 'endsub'
	Local $x = ''
	Local $aSubDefinitions[0]
	For $i = 0 To UBound($aString) - 1 Step 1
		$s = $aString[$i]
		Select
			Case Ex($s, $EX_sub_start)
				$x = StringTrimRight(StringTrimLeft($s, StringLen('sub ')), StringLen('()'))
				ArrayPush($aSubDefinitions, $x)
				ArrayPush($aSubroutines, $x)
;~ 				ConsoleWrite('sub: ' & $i & ': ' & $s & '-> name = ' & $x & @CRLF)
				$aString[$i] = _
				'goto(' & $LABEL_SUB_END & $x & ')' & @CRLF & _ ; Sub immer überspringen, falls der Interpreter an diese Stelle kommt
				$LABEL_SUB_START & $x ; Label für den Start der Sub
			Case Ex($s, $EX_sub_end)
				If UBound($aSubDefinitions) > 0 Then
					$aString[$i] = _
					'goto(' & $VAR_SUB_RETURNPOINTER & $x & ')' & @CRLF & _
					$LABEL_SUB_END & ArrayPop($aSubDefinitions)
				Else
					ErrorPush(3, $i, $s, 2, 'cannot find "sub" for this "endsub"')
				EndIf
;~ 				ConsoleWrite('endsub: ' & $i & ': ' & $s & @CRLF)
		EndSelect
		$sRet &= $aString[$i] & @CRLF
	Next
	Return StringTrimRight($sRet, 2)

;~ Sub mySub()
;~ -> Funktion ohne Parameter und ohne Returnwert die komplett auf dem Prozessor läuft
;~ EndSub

;~ Jump #ENDSUB_mySub always
;~ #SUB_mySub
;~ set @counter to returnpointer
;~ #ENDSUB_mySub

EndFunc

Func _Compile_Stage_3_For(ByRef $sString)
	Local $aString = StringSplit($sString, @CRLF, 3), $sRet = '', $s = ''
	Local $a, $v, $iForCounter = 0
	Local $ForDefinitions[0][3] ; [0] = increment Function, [1] = while-bedingung, [2] = Index der For-Schleife
	For $i = 0 To UBound($aString) - 1 Step 1
		$s = $aString[$i]
		Select
			Case Ex($s, $EX_LOOP_START)
				ArrayPush($ForDefinitions, Array(-1, -1, $iForCounter))
				$aString[$i] = $LABEL_FOR_START & $iForCounter
				$iForCounter += 1
			Case Ex($s, $EX_FOR_START)
				$a = StringSplit(StringTrimRight(StringTrimLeft($s, 4), 1), ',', 2)
				If UBound($a) = 3 Then
					ArrayPush($ForDefinitions, Array($a[2], $a[1], $iForCounter))
					$aString[$i] = _
						$a[0] & @CRLF & _
						'if(' & InvertLogic($a[1]) & ')goto(' & $LABEL_FOR_END & $iForCounter & ')' & @CRLF & _
						$LABEL_FOR_START & $iForCounter
						$iForCounter += 1
				Else
					ErrorPush(3, $i, $s, 1, 'For loop head wrong', 'It should be like: For(i=0,i<5,i++) ... next')
					ArrayPush($ForDefinitions, Array('err' & $i, 'err' & $i, 'err' & $i))
					$aString[$i] = 'SyntaxError: For(i=0,i<3,i++) ... Next'
					$iForCounter += 1
				EndIf
			Case Ex($s, $EX_LOOP_END)
				$v = ArrayPop($ForDefinitions)
				If UBound($v) = 3 And $v[0] = -1 And $v[1] = -1 Then
					$aString[$i] = 'goto(' & $LABEL_FOR_START &  $v[2] & ')' & @CRLF & _
					$LABEL_FOR_END &  $v[2]
				Else
					ErrorPush(3, $i, $s, 2, 'cannot find "loop" for this "endloop"')
				EndIf
			Case Ex($s, $EX_FOR_END)
				$v = ArrayPop($ForDefinitions)
				If UBound($v) = 3 And $v[0] <> -1 And $v[1] <> -1 Then
					$aString[$i] = _
					$v[0] & @CRLF & _
					'if(' & $v[1] & ')goto(' & $LABEL_FOR_START &  $v[2] & ')' & @CRLF & _
					$LABEL_FOR_END &  $v[2]
				Else
					ErrorPush(3, $i, $s, 3, 'cannot find "for" for this "next"')
				EndIf
		EndSelect
		$sRet &= $aString[$i] & @CRLF
	Next
	Return StringTrimRight($sRet, 2)
EndFunc

Func _Compile_Stage_3b_ExitloopContinueLoop(ByRef $sString)
	Local $aString = StringSplit($sString, @CRLF, 3), $sRet = '', $s = ''

;~ 	Local Const $EX_if_exitloop = 'if\('&$EX_VAR&$REGEX_CHAR_RELATION_OPERATORS&'{1,2}'&$EX_VAR&'\)exitloop'
;~ 	Local Const $EX_if_continueloop = 'if\('&$EX_VAR&$REGEX_CHAR_RELATION_OPERATORS&'{1,2}'&$EX_VAR&'\)continueloop'
	Local $a
	For $i = 0 To UBound($aString) - 1 Step 1
		$s = $aString[$i]
		Select
			Case Ex($s, $EX_LOOP_EXIT)
				For $ii = $i + 1 To UBound($aString) - 1 Step 1
					If StringLeftEquals($aString[$ii], $LABEL_FOR_END) Then
						$aString[$i] = 'goto(' & $aString[$ii] & ')'
						ExitLoop
					EndIf
				Next
			Case Ex($s, $EX_IF_LEXIT)
				$a = StringSplit(StringTrimLeft($s, 3), ')', 2)
				If Not @error Then
					For $ii = $i + 1 To UBound($aString) - 1 Step 1
						If StringLeftEquals($aString[$ii], $LABEL_FOR_END) Then
							$aString[$i] = 'if('&$a[0]&')goto(' & $aString[$ii] & ')'
							ExitLoop
						EndIf
					Next
				EndIf
			Case Ex($s, $EX_LOOP_CONTINUE)
				For $ii = $i + 1 To UBound($aString) - 1 Step 1
					If StringLeftEquals($aString[$ii], $LABEL_FOR_END) Then
						$aString[$i] = 'goto(' & $aString[$ii] & '-2)'
						ExitLoop
					EndIf
				Next
			Case Ex($s, $EX_IF_LCONTINUE)
				$a = StringSplit(StringTrimLeft($s, 3), ')', 2)
				If Not @error Then
					For $ii = $i + 1 To UBound($aString) - 1 Step 1
						If StringLeftEquals($aString[$ii], $LABEL_FOR_END) Then
							$aString[$i] = 'if('&$a[0]&')goto(' & $aString[$ii] & '-2)'
							ExitLoop
						EndIf
					Next
				EndIf
		EndSelect
		$sRet &= $aString[$i] & @CRLF
	Next
	Return StringTrimRight($sRet, 2)
EndFunc



Func _Compile_Stage_3b_If(ByRef $sString)
	Local $aString = StringSplit($sString, @CRLF, 3), $sRet = '', $s = ''
	Local Const $EX_if_else = 'else'
	Local Const $EX_if_end = 'endif'
	Local $a, $x, $v
	Local $IfDefinitions[0], $iIfCounter = 0
	Local $ElseDefinitions[0], $ec = 0
	For $i = 0 To UBound($aString) - 1 Step 1
		$s = $aString[$i]
		If Not $s Then ContinueLoop
		Select
			Case StringRegExpMatchLine($s, $EX_IF) ; Enthält If(...)
				Local $aSplit = StringRegExpSplitLine($s, $EX_IF)
				ArrayPush($IfDefinitions, $iIfCounter)
				$aString[$i] = 'if(' & InvertLogic($aSplit) & ')goto(' & $LABEL_IF_START & $iIfCounter & ')'
				$iIfCounter += 1
			Case StringRegExpMatchLine($s, $EX_if_else)
				$x = ArrayPop($IfDefinitions)
				ArrayPush($IfDefinitions, 'end' & $x)
				$aString[$i] = 'goto(' & $LABEL_IF_START & 'end' & $x & ')' & @CRLF
				$aString[$i] &= $LABEL_IF_START & $x
			Case StringRegExpMatchLine($s, $EX_if_end)
				$x = ArrayPop($IfDefinitions)
				If @error Then
					ErrorPush(3, $i, $aString[$i], 1, 'cannot find "if" for this "endif"')
					$aString[$i] = '#if_ERROR_NO_IF_FOUND'
				Else
					$aString[$i] = $LABEL_IF_START & $x
				EndIf
		EndSelect
		$sRet &= $aString[$i] & @CRLF
	Next
	Return StringTrimRight($sRet, 2)
EndFunc