#include-once
#include '../Util.au3'



Func _Compile_Stage_4(ByRef $sString)

	$sString = __Compile4_ExtendLanguage_Calls($sString) ; Kandidaten für "#Define" Funktionalität
	$sString = __Compile4_ExtendLanguage_Funcs($sString) ; Kandidaten für "#Define" Funktionalität

	; a = Array(cell1) -> $ArrayStorage['a'] = cell1
	; a[00] = 1
	; a[60] = 1
	; b = a[50]

	; write 1 $ArrayStorage['a'] 00
	; read b $ArrayStorage['a'] 50


	__Compile4_IfSingleArg($sString) ; If(a)anything -> if(a!=0)anything
	__Compile4_IfSingleLine($sString) ; If(a=0)anything -> if(a=0) \n anything \n endif

	__Compile4_Array($sString)


EndFunc

Func __Compile4_Array(ByRef $sString)
	Local $aString = StringSplit($sString, @CRLF, 3), $sRet = '', $sLine = ''
	For $i = 0 To UBound($aString) - 1 Step 1
		$sLine = $aString[$i]
		Select
			Case StringRegExpMatchLine($aString[$i], $EX_READARRAY)
				Local $aSplit = StringRegExpSplitLine($aString[$i], $EX_READARRAY)
				$sLine = $aSplit[0] & '=Read(' & $_DEF_ARRAY[$aSplit[1]] & ',' &  $aSplit[2] & ')'
			Case StringRegExpMatchLine($aString[$i], $EX_WRITEARRAY)
				Local $aSplit = StringRegExpSplitLine($aString[$i], $EX_WRITEARRAY)
				$sLine = 'Write(' & $aSplit[2] & ',' & $_DEF_ARRAY[$aSplit[0]] & ',' & $aSplit[1] & ')'
		EndSelect
		$sRet &= $sLine & @CRLF
	Next
	$sString = StringTrimRight($sRet, 2)
EndFunc

Func __Compile4_IfSingleArg(ByRef $sString)
	Local $aString = StringSplit($sString, @CRLF, 3), $sRet = '', $sLine = ''
	For $i = 0 To UBound($aString) - 1 Step 1
		$sLine = $aString[$i]
		Select
			Case StringRegExpMatchLine($sLine, $EX_IFSINGLE)
				Local $aSplit = StringRegExpSplitLine($sLine, $EX_IFSINGLE)
				$sLine = 'if(' & $aSplit[0] & '!=0)' & $aSplit[1]
			Case StringRegExpMatchLine($sLine, $EX_IFSINGLENEG)
				Local $aSplit = StringRegExpSplitLine($sLine, $EX_IFSINGLENEG)
				$sLine = 'if(' & $aSplit[0] & '=0)' & $aSplit[1]
		EndSelect
		$sRet &= $sLine & @CRLF
	Next
	$sString = StringTrimRight($sRet, 2)
EndFunc

Func __Compile4_IfSingleLine(ByRef $sString) ; Umformen von If(...)anything -> If(...) \n anything \n endif
	Local $aString = StringSplit($sString, @CRLF, 3), $sRet = '', $sLine = ''
	For $i = 0 To UBound($aString) - 1 Step 1
		$sLine = $aString[$i]
		Select
			Case StringRegExpMatchLine($sLine, $EX_ANYIF)
				Local $aSplit = StringRegExpSplitLine($sLine, $EX_ANYIF)
				If Not ($aSplit[1] = '' Or StringLeftEquals($aSplit[1], 'goto')) Then
					$sLine = 'if(' & $aSplit[0] & ')' & @CRLF & $aSplit[1] & @CRLF & 'endif'
				EndIf
		EndSelect
		$sRet &= $sLine & @CRLF
	Next
	$sString = StringTrimRight($sRet, 2)
EndFunc


Func __Compile4_ExtendLanguage_Calls(ByRef $sString)
	Local $aString = StringSplit($sString, @CRLF, 3), $aSplit, $sRet = ''

	Local Static $EX_CALL_V           = RegExpCall('var')
	Local Static $EX_CALL_VON_VON_VON = RegExpCall('varornumber varornumber varornumber')

	For $i = 0 To UBound($aString) - 1 Step 1
		Select

			Case StringRegExpMatchLine($aString[$i], $EX_CALL_V) ; [0]([1])
				$aSplit = StringRegExpSplitLine($aString[$i], $EX_CALL_V)
				Switch StringLower($aSplit[0])
					Case 'enable'
						$aString[$i] = 'enabled(' & $aSplit[1] & ',1)'
					Case 'disable'
						$aString[$i] = 'enabled(' & $aSplit[1] & ',0)'
				EndSwitch

			Case StringRegExpMatchLine($aString[$i], $EX_CALL_VON_VON_VON) ; [0]([1],[2],[3])
				$aSplit = StringRegExpSplitLine($aString[$i], $EX_CALL_VON_VON_VON)
				Switch StringLower($aSplit[0])
					Case 'color'
						$aString[$i] = 'color(' & $aSplit[1] & ',' & $aSplit[2] & ',' & $aSplit[3] & ',255)'
				EndSwitch

		EndSelect
		$sRet &= $aString[$i] & @CRLF
	Next
	Return StringTrimRight($sRet, 2)
EndFunc

Func __Compile4_ExtendLanguage_Funcs(ByRef $sString)
	Local $aString = StringSplit($sString, @CRLF, 3), $aSplit, $sRet = ''

	Local Static $EX_FUNC         = RegExpFunc('')
	Local Static $EX_FUNC_VON     = RegExpFunc('varornumber')
	Local Static $EX_FUNC_VON_VON = RegExpFunc('varornumber varornumber')

	For $i = 0 To UBound($aString) - 1 Step 1
		Select

			Case StringRegExpMatchLine($aString[$i], $EX_FUNC) ; [0] = [1]()
				$aSplit = StringRegExpSplitLine($aString[$i], $EX_FUNC)
				Switch StringLower($aSplit[1])
					Case 'random'
						$aString[$i] = $aSplit[0] & '=random(1)'
				EndSwitch

			Case StringRegExpMatchLine($aString[$i], $EX_FUNC_VON)
				$aSplit = StringRegExpSplitLine($aString[$i], $EX_FUNC_VON) ; [0] = [1]([2])
				Switch StringLower($aSplit[1])
					Case 'chance'
						$aString[$i] = _
							$aSplit[0] & '=random(1)' & @CRLF & _
							$aSplit[0] & '=' & $aSplit[0] & '<' & $aSplit[2]
				EndSwitch

			Case StringRegExpMatchLine($aString[$i], $EX_FUNC_VON_VON)
				$aSplit = StringRegExpSplitLine($aString[$i], $EX_FUNC_VON_VON) ; [0] = [1]([2],[3])
				Switch StringLower($aSplit[1])
					Case 'random'
						$aString[$i] = _
							$aSplit[0] & '=' & $aSplit[3] & '-' & $aSplit[2] & @CRLF & _
							$aSplit[0] & '=random(' & $aSplit[0] & ')' & @CRLF & _
							$aSplit[0] & '+=' & $aSplit[2]
				EndSwitch

		EndSelect
		$sRet &= $aString[$i] & @CRLF
	Next
	Return StringTrimRight($sRet, 2)
EndFunc
