#include-once
#include '../Util.au3'

#include <Array.au3>

; Stage Z (Preprocessing)
; Kommentate entfernen $ Das ist ein Kommentar
; a = 5 $Inlinekommentar$ + 3
; Leerzeichen entfernen (außer sie sind zwingend nötig wie bei "func myfunc()")
; Leerzeilen entfernen
; Scan für Funktionen und Subroutinen (Namen und Anzahl Parameter ermitteln.

Func _Compile_Stage_Z(ByRef $sString)
	_Compile_Stage_Z_RemoveComments($sString)
	_Compile_Stage_Z_RemoveEmptyLinesAndWhiteSpace($sString)
	__CompileZ_GlobalConstants($sString)
	_Compile_Stage_Z_Scan($sString)
EndFunc

Func __CompileZ_GlobalConstants(ByRef $sString)
	Local Static $REPLACE = [ _
		['SIZE_CELL',        64], _
		['SIZE_BIGCELL',    512], _
		['SIZE_DISPLAY',     80], _
		['SIZE_BIGDISPLAY', 176]]
	For $i = 0 To UBound($REPLACE) - 1 Step 1
		$sString = StringReplace($sString, $REPLACE[$i][0], $REPLACE[$i][1], 0, 1)
	Next
EndFunc

Func _Compile_Stage_Z_Scan(ByRef $sString)
	$_DEF_SUB = MapEmpty()
	$_DEF_FUN = MapEmpty()
	$_DEF_ARRAY = MapEmpty()
	Local $aString = StringSplit($sString, @CRLF, 3), $sRet = ''
	For $i = 0 To UBound($aString) - 1 Step 1
		Select
			Case Ex($aString[$i], $EX_SUB_START0)
				$_DEF_SUB[StringTrimBoth($SYNTAX_SUB_START, $aString[$i], '()')] = 0
			Case Ex($aString[$i], $EX_FUNC_START0)
				$_DEF_FUN[StringTrimBoth($SYNTAX_FUNC_START, $aString[$i], '()')] = 0
			Case StringRegExpMatchLine($aString[$i], $EX_DEFARRAY)
				Local $aSplit = StringRegExpSplitLine($aString[$i], $EX_DEFARRAY)
				$_DEF_ARRAY[$aSplit[0]] = $aSplit[1]
				$aString[$i] = '' ; Die Zeile kann weg, nachdem sie eingescannt wurde.
		EndSelect
		If $aString[$i] Then $sRet &= $aString[$i] & @CRLF
	Next
	$sString = StringStripWS($sRet, 2)
EndFunc

; Entfernt allen Whitespace der nicht nötig ist.
; Whitespace in Strings bleibt erhalten
; Whitespace der syntaktisch relevant ist (z.B. func myfunc()) bleibt erhalten.
Func _Compile_Stage_Z_RemoveEmptyLinesAndWhiteSpace(ByRef $sString)
	Local $aString = StringSplit($sString, @CRLF, 3), $sRet = '', $sLine = ''
	For $i = 0 To UBound($aString) - 1 Step 1
		$sLine = StringStripWS($aString[$i], 3)
		Select
			Case StringLeftEquals($sLine, $SYNTAX_SUB_START)
				$sLine = $SYNTAX_SUB_START & StringTrimLeft(StringStripWS2($sLine), StringLen($SYNTAX_SUB_START) - 1)
			Case StringLeftEquals($sLine, $SYNTAX_SUB_START)
				$sLine = $SYNTAX_SUB_START & StringTrimLeft(StringStripWS2($sLine), StringLen($SYNTAX_SUB_START) - 1)
			Case Else
				$sLine = StringStripWS2($sLine)
		EndSelect
		If Not $sLine Then ContinueLoop
		$sRet &= $sLine & @CRLF
	Next
	$sString = StringTrimRight($sRet, 2)
EndFunc

; Entfernt alle Kommentare.
; Ab ";" ist alles ein Kommentar
; Alles zwischen zwei ";" ist ein Kommentar, z.B. ; ich bin ein Kommentar ;
Func _Compile_Stage_Z_RemoveComments(ByRef $sString)
	Local $aString = StringSplit($sString, @CRLF, 3), $sRet = '', $sLine = '', $aLine[0], $iInsideComment = 0, $iInsideString = 0
	For $i = 0 To UBound($aString) - 1 Step 1
		$aLine = StringSplit($aString[$i], '', 2)
		$sLine = ''
		$iInsideComment = 0
		$iInsideString = 0
		For $c = 0 To UBound($aLine) - 1 Step 1
			If $aLine[$c] = $SYNTAX_STRING And Not $iInsideComment Then
				$iInsideString = 1 - $iInsideString
			EndIf
			If $aLine[$c] = $SYNTAX_COMMENT And Not $iInsideString Then
				$iInsideComment = 1 - $iInsideComment
				If $c = UBound($aLine) - 1 Then ExitLoop
				If Not $iInsideComment Then $c += 1
			EndIf
			If Not $iInsideComment Or $iInsideString Then $sLine &= $aLine[$c]
		Next
		$sRet &= $sLine & @CRLF
		If $iInsideString Then ErrorPush('Z', $i, $aString[$i], 1, 'string not closed')
	Next
	$sString = StringTrimRight($sRet, 2)
EndFunc
