#include-once
#include 'Util/Map.au3'
#include 'Util/String.au3'
#include 'Util/Constants.au3'
#include <Array.au3>

Global $_DEF_SUB[] ; $_DEF_SUB.name = numParams
Global $_DEF_FUN[] ; $_DEF_FUN.name = numParams
Global $_DEF_ARRAY[] ; $_DEF_ARRAY['name'] = cell1

Global $aError[0]
Global $aSubroutines[0] ; Enthält alle Namen aller Subroutinen
Global $aFunctions[0] ;



Func Array2Console($a)
	ConsoleWrite('Array[' & UBound($a) & ']' & @CRLF)
	For $i = 0 To UBound($a) -1 Step 1
		ConsoleWrite('[' & StringRight('  ' & $i, 2) & '] ' & $a[$i] & @CRLF)
	Next
EndFunc

Func ErrorPush($iStage, $iLine, $sLine, $iErrorCode, $sErrorString, $sFix = '')
	Local $a[7]
	$a[0] = $iStage
	$a[1] = $iLine
	$a[2] = $sLine
	$a[3] = $iErrorCode
	$a[4] = $sErrorString
	$a[5] = $sFix
	ArrayPush($aError, $a)
EndFunc

Func ConvertY($bLargeDisplay, $y)
	If $bLargeDisplay Then Return $DISPLAY_SIZE_LARGE - $y
	Return $DISPLAY_SIZE_SMALL - $y
EndFunc


Func Between($left, $x, $right)
	Return $x >= $left And $x <= $right
EndFunc   ;==>Between



Func InvertLogic($s)
	If IsArray($s) Then
		Switch $s[1]
			Case '='
				Return $s[0] & '!=' & $s[2]
			Case '=='
				Return $s[0] & '!=' & $s[2]
			Case '!='
				Return $s[0] & '=' & $s[2]
			Case '<>'
				Return $s[0] & '=' & $s[2]
			Case '<='
				Return $s[0] & '>' & $s[2]
			Case '>='
				Return $s[0] & '<' & $s[2]
			Case '<'
				Return $s[0] & '>=' & $s[2]
			Case '>'
				Return $s[0] & '<=' & $s[2]
		EndSwitch
	Else
		If StringInStr($s, '==') Then Return StringSplit($s, '==', 3)[0] & '!=' & StringSplit($s, '==', 3)[1]
		If StringInStr($s, '!=') Then Return StringSplit($s, '!=', 3)[0] & '==' & StringSplit($s, '!=', 3)[1]
		If StringInStr($s, '<>') Then Return StringSplit($s, '<>', 3)[0] & '==' & StringSplit($s, '<>', 3)[1]
		If StringInStr($s, '<=') Then Return StringSplit($s, '<=', 3)[0] & '>' & StringSplit($s, '<=', 3)[1]
		If StringInStr($s, '>=') Then Return StringSplit($s, '>=', 3)[0] & '<' & StringSplit($s, '>=', 3)[1]
		If StringInStr($s, '=') Then Return StringSplit($s, '=', 3)[0] & '!=' & StringSplit($s, '=', 3)[1]
		If StringInStr($s, '<') Then Return StringSplit($s, '<', 3)[0] & '>=' & StringSplit($s, '<', 3)[1]
		If StringInStr($s, '>') Then Return StringSplit($s, '>', 3)[0] & '<=' & StringSplit($s, '>', 3)[1]
	EndIf
	ErrorPush(0, 0, $s, 0, 'Nicht invertierbar')
	Return $s
EndFunc   ;==>InvertLogic

Func ArrayPush1D(ByRef $a, $v)
	Local $u = UBound($a)
	ReDim $a[$u + 1]
	$a[$u] = $v
EndFunc   ;==>ArrayPush1D

Func ArrayPush2D(ByRef $a, $av)
	Local $u = UBound($a)
	ReDim $a[$u + 1][UBound($a, 2)]
	For $i = 0 To UBound($a, 2) - 1 Step 1
		$a[$u][$i] = $av[$i]
	Next
EndFunc   ;==>ArrayPush2D

Func ArrayPush(ByRef $a, $b)
	Switch UBound($a, 0)
		Case 1
			Return ArrayPush1D($a, $b)
		Case 2
			Return ArrayPush2D($a, $b)
	EndSwitch
EndFunc   ;==>ArrayPush

Func ArrayPop(ByRef $a)
	Switch UBound($a, 0)
		Case 1
			Local $v = ArrayPop1D($a)
			If @error Then Return SetError(1, 0, 0)
			Return $v
		Case 2
			Local $v = ArrayPop2D($a)
			If @error Then Return SetError(1, 0, 0)
			Return $v
	EndSwitch
EndFunc   ;==>ArrayPop

Func ArrayPeek(ByRef $a)
	Switch UBound($a, 0)
		Case 1
			Local $v = ArrayPeek1D($a)
			If @error Then Return SetError(1, 0, 0)
			Return $v
		Case 2
			Local $v = ArrayPeek2D($a)
			If @error Then Return SetError(1, 0, 0)
			Return $v
	EndSwitch
EndFunc   ;==>ArrayPop

Func ArrayPop2D(ByRef $a)
	Local $u = UBound($a) - 1, $uu = UBound($a, 2), $v[$uu]
	If $u < 0 Then Return SetError(1, 0, 0)
	For $i = 0 To $uu - 1 Step 1
		$v[$i] = $a[$u][$i]
	Next
	ReDim $a[$u][$uu]
	Return $v
EndFunc   ;==>ArrayPop2D

Func ArrayPop1D(ByRef $a)
	If UBound($a) = 0 Then Return SetError(1, 0, 0)
	Local $v = $a[UBound($a) - 1]
	ReDim $a[UBound($a) - 1]
	Return $v
EndFunc   ;==>ArrayPop1D

Func ArrayPeek2D(ByRef $a)
	Local $u = UBound($a) - 1, $uu = UBound($a, 2), $v[$uu]
	If $u < 0 Then Return SetError(1, 0, 0)
	For $i = 0 To $uu - 1 Step 1
		$v[$i] = $a[$u][$i]
	Next
	Return $v
EndFunc   ;==>ArrayPop2D

Func ArrayPeek1D(ByRef $a)
	If UBound($a) = 0 Then Return SetError(1, 0, 0)
	Return $a[UBound($a) - 1]
EndFunc   ;==>ArrayPop1D

Func Array($1 = '', $2 = '', $3 = '', $4 = '', $5 = '', $6 = '')
	Switch @NumParams
		Case 0
			Local $_[0]
			Return $_
		Case 1
			Local $_ = [$1]
			Return $_
		Case 2
			Local $_ = [$1, $2]
			Return $_
		Case 3
			Local $_ = [$1, $2, $3]
			Return $_
		Case 4
			Local $_ = [$1, $2, $3, $4]
			Return $_
		Case 5
			Local $_ = [$1, $2, $3, $4, $5]
			Return $_
		Case 6
			Local $_ = [$1, $2, $3, $4, $5, $6]
			Return $_
	EndSwitch
EndFunc   ;==>Array