#include-once
#include 'Constants.au3'

Func RegExpLine($sPattern)
	Return $REGEX_LINE_START & $sPattern & $REGEX_LINE_END
EndFunc

Func RegExpCall($sTypes = '', $sFuncName = '')
	Local $aTypes = StringSplit($sTypes, ' ', 2), $bEmpty = (@error <> 0) And Not $aTypes[0], $sRet = ($sFuncName ? ('(' & $sFuncName & ')') : $EX_FUNC) & '\('
;~ 	ConsoleWrite($bEmpty & @CRLF)
	If Not $bEmpty Then
		Local $iParams = UBound($aTypes)
		For $i = 0 To $iParams - 1 Step 1
			$sRet &= $PARAM_TYPE[$aTypes[$i]] & (($i <> $iParams - 1) ? ',' : '')
		Next
	EndIf
	Return $sRet & '\)'
	; RegExpCall("var var") -> match für myFunc(a,b)
EndFunc

Func RegExpFunc($sTypes = '', $sFuncName = '')
	Local $aTypes = StringSplit($sTypes, ' ', 2), $bEmpty = (@error <> 0) And Not $aTypes[0], $sRet = $EX_VAR & '=' & ($sFuncName ? ('(' & $sFuncName & ')') : $EX_FUNC) & '\('
;~ 	ConsoleWrite($bEmpty & @CRLF)
	If Not $bEmpty Then
		Local $iParams = UBound($aTypes)
		For $i = 0 To $iParams - 1 Step 1
			$sRet &=  $PARAM_TYPE[$aTypes[$i]] & (($i <> $iParams - 1) ? ',' : '')
		Next
	EndIf
	Return $sRet & '\)'
	; RegExpFunc("var var") -> match für a=myFunc(b,c)
EndFunc

; RegEx Generator für Funktionen
Func StringRegExpForFunction($sFuncName, $iParams = 0)
	Local $sRet = '(' & $EX_VAR & ')(' & $REGEX_CHAR_MATH_OPERATORS & '{1,2}' & ')(' & StringUpper($sFuncName) & ')\('
	For $i = 0 To $iParams - 1 Step 1
		$sRet &= '(' & $REGEX_OPTIONAL_PLUSMINUS & $EX_VAR & ')' & (($i <> $iParams - 1) ? ',' : '')
	Next
	Return $sRet & '\)'
	; Groups:
	; [1]  [2]    [3]       [4]      [i]
	; var  +=  function ( prarm1 , paramN )
EndFunc

; RegEx Generator für Aufrufe
Func StringRegExpForCalls($sFuncName, $iParams = 0)
	Local $sRet = '(' & StringUpper($sFuncName) & ')\('
	For $i = 0 To $iParams - 1 Step 1
		$sRet &= '(' & $REGEX_OPTIONAL_PLUSMINUS & $EX_VAR & ')' & (($i <> $iParams - 1) ? ',' : '')
	Next
	Return $sRet & '\)'
	; Groups:
	;    [1]       [2]      [i]
	; function ( prarm1 , paramN )
EndFunc

; RegEx Generator für Aufrufe
Func StringRegExpForCallsString($sFuncName, $iParams = 0)
	Local $sRet = '(' & StringUpper($sFuncName) & ')\('
	For $i = 0 To $iParams - 1 Step 1
		$sRet &= '("' & $EX_STRING & '")' & (($i <> $iParams - 1) ? ',' : '')
	Next
	Return $sRet & '\)'
	; Groups:
	;    [1]         [2]      [i]
	; function ( "prarm1" , "paramN" )
EndFunc

; Regex für komplette Zeile anwenden.
Func StringRegExpSplitLine($sText, $sPattern)
	Return StringRegExp($sText, $REGEX_LINE_START & $sPattern & $REGEX_LINE_END, 1)
EndFunc

Func StringRegExpMatchLine($sText, $sPattern)
	Return StringRegExp($sText, $REGEX_LINE_START & $sPattern & $REGEX_LINE_END)
EndFunc

; Schnelltest
Func Ex($sText, $sPattern)
	Return StringRegExp($sText, $REGEX_LINE_START & $sPattern & $REGEX_LINE_END)
EndFunc


Func StringRepeat($sString, $iCount)
	Local $_ = ''
	For $i = 0 To $iCount - 1 Step 1
		$_ &= $sString
	Next
	Return $_
EndFunc

; All in one Split funktion. Kann z.B. a = b + c nach = und + splitten und jedes Teil einzeln noch trimmen.
Func Split($sInput, $sDelimiter1, $sDelimiter2 = '', $sDelimiter3 = '', $0TL = 0, $0TR = 0, $1TL = 0, $1TR = 0, $2TL = 0, $2TR = 0)
	Local $a = StringSplit(StringTrimBoth($sInput, $0TL, $0TR), $sDelimiter1, 3), $l[0], $r[0]
	If $sDelimiter2 = '' Then
		$l = StringTrimBoth($a[0], $1TL, $1TR)
	Else
		$l = StringSplit(StringTrimBoth($a[0], $1TL, $1TR), $sDelimiter2, 3)
	EndIf
	If $sDelimiter3 = '' Then
		Local $aR[UBound($a) - 1]
		For $i = 0 To UBound($aR) - 1 Step 1
			$aR[$i] = StringTrimBoth($a[$i + 1], $2TL, $2TR)
		Next
		$r = $aR

	Else
		$r = StringSplit(StringTrimBoth($a[1], $2TL, $2TR), $sDelimiter3, 3)
	EndIf
	Local $aRet[(IsArray($l) ? UBound($l) : 1) + (IsArray($r) ? UBound($r) : 1)]
	If IsArray($l) Then
		For $i = 0 To UBound($l) - 1 Step 1
			$aRet[$i] = $l[$i]
		Next
	Else
		$aRet[0] = $l
	EndIf
	If IsArray($r) Then
		For $i = 0 To UBound($r) - 1 Step 1
			$aRet[$i + (IsArray($l) ? UBound($l) : 1)] = $r[$i]
		Next
	Else
		$aRet[(IsArray($l) ? UBound($l) : 1)] = $r
	EndIf
	Return $aRet
EndFunc   ;==>Split

; Checkt ob die Linke Seite eines Strings gleich ist
Func StringLeftEquals($sString, $sLeft)
	Return StringLeft($sString, StringLen($sLeft)) = $sLeft
EndFunc   ;==>StringLeftEquals

; Kombination aus StringTrimLeft und StringTrimRight
; Erlaubt auch Strings als eingabe für Left & Right, dann wird die Stringlänge verwendet.
Func StringTrimBoth($sString, $xLeft, $xRight)
	Return StringTrimRight(StringTrimLeft($sString, IsInt($xLeft) ? $xLeft : StringLen($xLeft)), IsInt($xRight) ? $xRight : StringLen($xRight))
EndFunc

Func StringSplitParams($sParams)
	Local $sDelim = StringFindNotExistingSubstring($sParams) ; Replace kommas -> delim, aber nur außerhalb von "strings".
	Local $aSplit = StringSplit($sParams, '', 2), $sSplit = '', $c = 0
	For $i = 0 To UBound($aSplit) - 1 Step 1
		Switch $aSplit[$i]
			Case '"'
				$c += 1
				$sSplit &= $aSplit[$i]
			Case ','
				If IsInt($c/2) Then
					$sSplit &= $sDelim
				Else
					$sSplit &= ','
				EndIf
			Case Else
				$sSplit &= $aSplit[$i]
		EndSwitch
	Next
	Local $aParams = StringSplit($sSplit, $sDelim, 3)
	If UBound($aParams) = 1 And $aParams[0] = '' Then ReDim $aParams[0]
	Return $aParams
EndFunc

Func StringFindNotExistingSubstring($sString, $iLen = 2)
	Local $sDelim = StringRandom($iLen)
	Return StringInStr($sString, $sDelim, 0, 1) ? StringFindNotExistingSubstring($sString) : $sDelim
EndFunc

Func StringRandom($iLen)
	Local Static $aSymbols = StringSplit('abcdefghijklmnopqrstuvwxyzäöüß0123456789', '', 2), $_ = UBound($aSymbols) - 1
	Local $sRet = ''
	For $i = 0 To $iLen - 1 Step 1
		$sRet &= $aSymbols[Random(0, $_)]
	Next
	Return $sRet
EndFunc

; Entfernt stämtlichen Whitespace
Func StringStripWS2($s)
	; Zeichenweise, entfernt alle Leerzeichen die nicht in "" stehen.
	Local $a = StringSplit($s, '', 2), $r = '', $c = 0
	For $i = 0 To UBound($a) - 1 Step 1
		If $a[$i] = $SYNTAX_STRING Then
			$c += 1
			$r &= $SYNTAX_STRING
			ContinueLoop
		EndIf
		If StringStripWS($a[$i], 8) = $a[$i] Then
			$r &= $a[$i]
		Else
			If Not IsInt($c / 2) Then $r &= ' '
		EndIf
	Next
	Return $r
EndFunc   ;==>StringStripWS2